#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <Hs.h>
#include <PalmOnePhoto.h>
#include <HsPhonePower.h>
#include <HsPhoneNetwork.h>
#include <HsPhoneLibrary.h>
#include <HsPhoneAudioTypes.h>
#include <HsPhoneGSM.h>
#include <PmSysGadgetLib.h>
#include <HsKeyCodes.h>
#include <BtLib.h>
#include <BtPrefsPnlTypes.h>
#include <PalmOS.h>
#include <Helper.h>
#include <HelperServiceClass.h>

#include "PhonePlugin.h"
#include "PhonePlugin_Rsc.h"
#include "Plugin.h"

static void settingEventHandler();
static Boolean arraySearchKMP(Int16 *nextVP, UInt32 *wordP, UInt16 wordLength, UInt32 *packageP, UInt16 packageLength);
static void convertCharsToBitPackage(Char *srcStringP, UInt32 *pyTableP, UInt32 *destUInt32BitPackageP, UInt16 *UInt32BitPackageLengthP);
static UInt16 StrDigitCopy(Char *dstString, Char *srcString);
static void paintCharsWithOutline(Char *stringP, UInt16 stringLength, Coord x, Coord y, RGBColorType *outlineColorP);
static void freeCallLog(GlobeType *globeP);
static void freeContactCategory(GlobeType *globeP);
static Boolean getContactUnitMemoryAndCategory(GlobeType *globeP);
static BitmapTypeV3 *getBackgdBitmap();
static void freeBmpResource(GlobeType *globeP);
static void getBmpResource(GlobeType *globeP);
static void getPYTable(GlobeType *globeP);
static void freeCallCard(GlobeType *globeP);
static void getPreferences(GlobeType *globeP);

#if 0
#pragma mark -
#pragma mark CONTACTS SEARCH FUNCTIONS
#pragma mark -
#endif

static void getPhoneLabelText(AddressPhoneLabels phoneLabel, Char *cacheP, Boolean shouldHasParentheses)
{
	if (shouldHasParentheses)
	{
		switch (phoneLabel)
		{
			case workLabel:
			{
				StrCat(cacheP, "(W)");
				break;
			}
			case homeLabel:
			{
				StrCat(cacheP, "(H)");
				break;
			}
			case faxLabel:
			{
				StrCat(cacheP, "(F)");
				break;
			}
			case otherLabel:
			{
				StrCat(cacheP, "(O)");
				break;
			}
			case emailLabel:
			{
				StrCat(cacheP, "(E)");
				break;
			}
			case mainLabel:
			{
				StrCat(cacheP, "(M)");
				break;
			}
			case pagerLabel:
			{
				StrCat(cacheP, "(P)");
				break;
			}
			case mobileLabel:
			{
				StrCat(cacheP, "(M)");
				break;
			}
		}
	}
	else
	{
		switch (phoneLabel)
		{
			case workLabel:
			{
				StrCopy(cacheP, "W");
				break;
			}
			case homeLabel:
			{
				StrCopy(cacheP, "H");
				break;
			}
			case faxLabel:
			{
				StrCopy(cacheP, "F");
				break;
			}
			case otherLabel:
			{
				StrCopy(cacheP, "O");
				break;
			}
			case emailLabel:
			{
				StrCopy(cacheP, "E");
				break;
			}
			case mainLabel:
			{
				StrCopy(cacheP, "M");
				break;
			}
			case pagerLabel:
			{
				StrCopy(cacheP, "P");
				break;
			}
			case mobileLabel:
			{
				StrCopy(cacheP, "M");
				break;
			}
		}
	}
}

//ǷӢϵ
static Boolean isEnglishContact(AddrDBRecordType *addrRecordP)
{
	Boolean		isEnglish	= true;
	Char		*stringP;
	
	if (addrRecordP->fields[name])
	{
		stringP = addrRecordP->fields[name];
		
		while(*stringP)
		{
			if (((UInt8)(*stringP)) > 127)
			{
				isEnglish = false;
				break;
			}
			stringP ++;
		}
	}
	
	if (isEnglishContact)
	{
		if (addrRecordP->fields[firstName])
		{
			stringP = addrRecordP->fields[firstName];
			
			while(*stringP)
			{
				if (((UInt8)(*stringP)) > 127)
				{
					isEnglish = false;
					break;
				}
				stringP ++;
			}
		}
	}
	
	return isEnglish;
}

//ȡ
static void getFullname(AddrDBRecordType *addrRecordP, Char *dscStringP, Boolean nameToShow)
{
	if (isEnglishContact(addrRecordP))	//Ӣģʽ
	{
		if (addrRecordP->fields[firstName])
		{
			StrCopy(dscStringP, addrRecordP->fields[firstName]);
			if (nameToShow)
			{
				StrCat(dscStringP, " ");
			}
		}
		if (addrRecordP->fields[name])
		{
			StrCat(dscStringP, addrRecordP->fields[name]);
		}
		if ((UInt8)dscStringP[0] == 0)
		{
			if (addrRecordP->fields[company])
			{
				StrCopy(dscStringP, addrRecordP->fields[company]);
			}
			else
			{
				StrCopy(dscStringP, "Unamed");
			}
		}
	}
	else	//ģʽ
	{
		if (addrRecordP->fields[name])
		{
			StrCopy(dscStringP, addrRecordP->fields[name]);
		}
		if (addrRecordP->fields[firstName])
		{
			StrCat(dscStringP, addrRecordP->fields[firstName]);
		}
		if ((UInt8)dscStringP[0] == 0)
		{
			if (addrRecordP->fields[company])
			{
				StrCopy(dscStringP, addrRecordP->fields[company]);
			}
			else
			{
				StrCopy(dscStringP, "δ");
			}
		}
	}
}

//ȡҪĺϵȽϵ绰ĺ8λ
static Boolean searchContactByPhoneNumber(UInt16 *recordIdP, Char *nameStringP, Char *phoneNumberP, UInt16 phoneNumberLength, GlobeType *globeP)
{
	Boolean				isFound			= false;
	DmOpenRef			dbRef			= DmOpenDatabaseByTypeCreator('DATA', 'PAdd', dmModeReadOnly);
	
	*recordIdP = 0;
	globeP->fieldMappingCount = 0;
	
	if (DmGetLastErr() == errNone)
	{
		MemHandle			recordH;
		UInt16				i;
		Char				*objPhoneNumberP;
		UInt16				objPhoneNumberLength;
		Char				*tmpPhoneNumberP		= phoneNumberP;
		UInt16				searchOffset			= 0;
		
		if (phoneNumberLength > 8)
		{
			tmpPhoneNumberP += (phoneNumberLength - 8);
		}
		
		//
		while (DmSeekRecordInCategory(dbRef, recordIdP, searchOffset, dmSeekForward, dmAllCategories) == errNone && isFound == false)
		{
			//ȡ¼
			MemSet(globeP->contactUnitP, sizeof(AddrDBRecordType), 0);
			if (AddrDBGetRecord(dbRef, *recordIdP, globeP->contactUnitP, &recordH) == errNone)
			{
				if (recordH)
				{
					MemHandleUnlock(recordH);
				}
				
				//Ƿ˽˼¼
				DmRecordInfo(dbRef, *recordIdP, &i, NULL, NULL);
				if (! (i & dmRecAttrSecret))	//񣬿ʾ
				{
					for (i = phone1; i <= phone7; i ++)
					{
						if (globeP->contactUnitP->fields[i])
						{
							objPhoneNumberP = globeP->contactUnitP->fields[i];
							objPhoneNumberLength = StrLen(objPhoneNumberP);
							if (objPhoneNumberLength >= phoneNumberLength)
							{
								if (objPhoneNumberLength > 8)
								{
									objPhoneNumberP += (objPhoneNumberLength - 8);
									objPhoneNumberLength -= (objPhoneNumberLength - 8);
								}
								
								if (StrStr(objPhoneNumberP, tmpPhoneNumberP))
								{
									isFound = true;
									
									//ȡ
									getFullname(globeP->contactUnitP, nameStringP, true);
									
									//ȡ绰
									getPhoneLabelText(GetPhoneLabel(globeP->contactUnitP, i), nameStringP, true);
								}
							}
						}
					}
				}
			}
			
			searchOffset = 1;
		}
		
		//رݿ
		DmCloseDatabase(dbRef);
	}
	
	return isFound;
}

//Ƿһ绰
static Boolean isPhoneNumberField(AddressPhoneLabels label)
{
	if (label == faxLabel || label == otherLabel || label == emailLabel || label == pagerLabel)
	{
		return false;
	}
	
	return true;
}

//ӳ
static Boolean buildFieldMapping(UInt16 recordId, GlobeType *globeP, UInt16 matchedField)
{
	UInt16			i;
	Boolean			isRecordHavePhoneField	= false;
	
	globeP->fieldMappingP[globeP->fieldMappingCount].recordId = recordId;
	globeP->fieldMappingP[globeP->fieldMappingCount].field = 0;
	if (matchedField == 0)
	{
		globeP->fieldMappingP[globeP->fieldMappingCount].matchType = MATCH_TYPE_NAME;
	}
	else
	{
		globeP->fieldMappingP[globeP->fieldMappingCount].matchType = MATCH_TYPE_NONE;
	}
	globeP->fieldMappingCount ++;
	
	for (i = phone1; i <= phone7; i ++)
	{
		if (globeP->contactUnitP->fields[i])
		{
			if (isPhoneNumberField(GetPhoneLabel(globeP->contactUnitP, i)))
			{
				globeP->fieldMappingP[globeP->fieldMappingCount].recordId = recordId;
				globeP->fieldMappingP[globeP->fieldMappingCount].field = (UInt8)i;
				if (i == matchedField)
				{
					globeP->fieldMappingP[globeP->fieldMappingCount].matchType = MATCH_TYPE_PHONE;
				}
				else
				{
					globeP->fieldMappingP[globeP->fieldMappingCount].matchType = MATCH_TYPE_NONE;
				}
				globeP->fieldMappingCount ++;
				isRecordHavePhoneField = true;
			}
		}
	}
	
	return isRecordHavePhoneField;
}

//ƥͨѶ¼
static void searchMatchedContactList(GlobeType *globeP)
{
	DmOpenRef			dbRef			= DmOpenDatabaseByTypeCreator('DATA', 'PAdd', dmModeReadOnly);
	
	globeP->fieldMappingCount = 0;
	
	if (DmGetLastErr() == errNone)
	{
		MemHandle			recordH;
		UInt16				attribute;
		UInt16				prevFieldMappingCount;
		UInt16				searchOffset			= 0;
		UInt16				recordId				= 0;
		UInt16				phoneNumberLength		= StrLen(globeP->phoneNumberP);
		
		//ѼؼתUInt32װ
		MemSet(globeP->contactSearchKeywordUInt32PackageP, 44, 0);
		convertCharsToBitPackage(globeP->contactSearchKeywordP, globeP->pyTableP, globeP->contactSearchKeywordUInt32PackageP, &globeP->contactSearchKeywordLength);
		
		//
		while (DmSeekRecordInCategory(dbRef, &recordId, searchOffset, dmSeekForward, globeP->contactsCategory) == errNone)
		{
			//ȡ¼
			MemSet(globeP->contactUnitP, sizeof(AddrDBRecordType), 0);
			if (AddrDBGetRecord(dbRef, recordId, globeP->contactUnitP, &recordH) == errNone)
			{
				if (recordH)
				{
					MemHandleUnlock(recordH);
				}
				
				//Ƿ˽˼¼
				DmRecordInfo(dbRef, recordId, &attribute, NULL, NULL);
				if (! (attribute & dmRecAttrSecret))	//񣬿ʾ
				{
					//ȡ
					getFullname(globeP->contactUnitP, globeP->cacheP, false);
					
					//תUInt32װ
					MemSet(globeP->nameUInt32PackageP, 512, 0);
					convertCharsToBitPackage(globeP->cacheP, globeP->pyTableP, globeP->nameUInt32PackageP, &globeP->nameUInt32PackageLength);
					
					//Ƿƥ
					MemSet(globeP->nextVP, 20, 0);
					prevFieldMappingCount = globeP->fieldMappingCount;
					if (globeP->contactSearchKeywordLength == 0)
					{
						if (! buildFieldMapping(recordId, globeP, 0xFFFF))
						{
							globeP->fieldMappingCount = prevFieldMappingCount;
						}
					}
					else if (arraySearchKMP(globeP->nextVP, globeP->contactSearchKeywordUInt32PackageP, globeP->contactSearchKeywordLength, globeP->nameUInt32PackageP, globeP->nameUInt32PackageLength))
					{
						if (! buildFieldMapping(recordId, globeP, 0))
						{
							globeP->fieldMappingCount = prevFieldMappingCount;
						}
					}
					else if (phoneNumberLength >= 3)	//Ƿϵ绰
					{
						for (attribute = phone1; attribute <= phone7; attribute ++)		//
						{
							if (globeP->contactUnitP->fields[attribute])
							{
								if (StrStr(globeP->contactUnitP->fields[attribute], globeP->phoneNumberP))
								{
									//ҵһ绰ƥļ¼
									if (! buildFieldMapping(recordId, globeP, attribute))
									{
										globeP->fieldMappingCount = prevFieldMappingCount;
									}
									break;
								}
							}
						}
					}
					
					MemSet(globeP->cacheP, 128, 0);
				}
			}
			
			searchOffset = 1;
		}
		
		//رݿ
		DmCloseDatabase(dbRef);
	}
}

#if 0
#pragma mark -
#pragma mark PHONE FUNCTIONS
#pragma mark -
#endif

#if 0
#pragma mark == PHONE COMMON FUNCTIONS ==
#endif

//ȡͨѶ¼
static void getCallLog(GlobeType *globeP)
{
	UInt16			i, j;
	UInt16			attribute;
	UInt16			recordNums;
	DmOpenRef		dbRef	= DmOpenDatabaseByTypeCreator('call', 'HsPh', dmModeReadOnly);
	
	freeCallLog(globeP);
	if (DmGetLastErr() == errNone)
	{
		recordNums = DmNumRecordsInCategory(dbRef, dmAllCategories);
		if (recordNums > 0)
		{
			globeP->callLogCount = DmNumRecordsInCategory(dbRef, globeP->callLogCategory);
			globeP->callLogListP = (CallLogItemType *)MemPtrNew((globeP->callLogCount + 1) * sizeof(CallLogItemType));
			
			j = 0;
			for (i = 0; i < recordNums; i ++)
			{
				DmRecordInfo(dbRef, i, &attribute, NULL, NULL);
				globeP->callLogListP[j].category = (UInt8)(attribute & dmRecAttrCategoryMask);
				if (globeP->callLogListP[j].category == globeP->callLogCategory || globeP->callLogCategory == dmAllCategories)
				{
					globeP->callLogListP[j].recordId = i;
					j ++;
				}
			}
		}
		DmCloseDatabase(dbRef);
	}
}

//ȡλ
static Int16 getScrollBarValue(GlobeType *globeP)
{
	Int16		value, min, max, pageSize;
	
	SclGetScrollBar(globeP->sclPhoneListP, &value, &min, &max, &pageSize);
	
	return value;
}

/*static void getSoundStatusBitmap()
{
	UInt16			i;
	UInt16			bmpSize;
	MemHandle		bmpRscH;
	DmOpenRef		dbRef		= DmOpenDatabaseByTypeCreator('appl', APPLICATION_CREATOR, dmModeReadOnly);
	
	for (i = 0; i < 10; i ++)
	{
		bmpRscH = DmGet1Resource('Tbmp', i + bmpSpeakerON);
		bmpSize = MemHandleSize(bmpRscH);
		
		globeP->bmpSoundStatusP[i] = (BitmapType *)MemPtrNew(bmpSize);
		MemMove(globeP->bmpSoundStatusP[i], MemHandleLock(bmpRscH), bmpSize);
		
		MemHandleUnlock(bmpRscH);
		DmReleaseResource(bmpRscH);
	}
	
	DmCloseDatabase(dbRef);
}*/

//þοΧ
static void setRectangle(GlobeType *globeP)
{
	globeP->backgdRectangle.topLeft.x = 0;
	globeP->backgdRectangle.topLeft.y = 0;
	globeP->backgdRectangle.extent.x = 160;
	globeP->backgdRectangle.extent.y = 160;
	globeP->statusBarRectangle.topLeft.x = 0;
	globeP->statusBarRectangle.topLeft.y = 0;
	globeP->statusBarRectangle.extent.x = 160;
	globeP->statusBarRectangle.extent.y = 13;
	globeP->datetimeBarRectangle.topLeft.x = 0;
	globeP->datetimeBarRectangle.topLeft.y = 0;
	globeP->datetimeBarRectangle.extent.x = 160;
	globeP->datetimeBarRectangle.extent.y = 13;
	globeP->tabRectangle.topLeft.x = 2;
	globeP->tabRectangle.topLeft.y = 2;
	globeP->tabRectangle.extent.x = 60;
	globeP->tabRectangle.extent.y = 10;
	globeP->listBarRectangle.topLeft.x = 2;
	globeP->listBarRectangle.topLeft.y = 39;
	globeP->listBarRectangle.extent.x = 156;
	globeP->listBarRectangle.extent.y = 99;
	globeP->dialPadRectangle.topLeft.x = 2;
	globeP->dialPadRectangle.topLeft.y = 56;
	globeP->dialPadRectangle.extent.x = 156;
	globeP->dialPadRectangle.extent.y = 102;
	globeP->phoneNumberRectangle[0].topLeft.x = 0;
	globeP->phoneNumberRectangle[0].topLeft.y = 14;
	globeP->phoneNumberRectangle[0].extent.x = 160;
	globeP->phoneNumberRectangle[0].extent.y = 22;
	globeP->phoneNumberRectangle[1] = globeP->phoneNumberRectangle[0];
	globeP->phoneNumberRectangle[1].extent.y = 22;
}

#if 0
#pragma mark == PHONE UI FUNCTIONS ==
#endif

static void drawPhoneNumber(Char *phoneNumberP, GlobeType *globeP)
{
	UInt16			i, n, maxY;
	MemHandle		bmpH[14];
	UInt16			phoneNumberLength	= StrLen(phoneNumberP);
	DmOpenRef		dbRef				= DmOpenDatabaseByTypeCreator('NlPh', APPLICATION_CREATOR, dmModeReadOnly);
	
	for (i = 0; i < 14; i ++)
	{
		bmpH[i] = DmGet1Resource('Tbmp', bmpZero + i);
		globeP->bmpCharP[i] = (BitmapType *)MemHandleLock(bmpH[i]);
	}
	
	WinSetCoordinateSystem(kCoordinatesDouble);
	
	if (globeP->contentType == CONTENT_TYPE_CALL_LOG || (globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
	{	//ʾ
		maxY = 60;
		if (phoneNumberLength > 11)
		{
			phoneNumberP += (phoneNumberLength - 11);
		}
	}
	else if (globeP->contentType == CONTENT_TYPE_DIAL_PAD)
	{	//ʾһ
		maxY = 60;
		if (phoneNumberLength > 11)
		{
			phoneNumberP += (phoneNumberLength - 11);
		}
	}
	else
	{	/*//ʾ
		maxY = 236;
		if (phoneNumberLength > 55)
		{
			phoneNumberP += (phoneNumberLength - 55);
		}*/
		maxY = 104;
		if (phoneNumberLength > 22)
		{
			phoneNumberP += (phoneNumberLength - 22);
		}
	}
	
	globeP->insPtX = 6;
	globeP->insPtY = 2*globeP->phoneNumberRectangle[0].topLeft.y;
	while (*phoneNumberP && globeP->insPtY <= maxY)
	{
		if(StrLen(phoneNumberP)>11)
		{
			paintCharsWithOutline(phoneNumberP,StrLen(phoneNumberP),
				globeP->phoneNumberRectangle[0].topLeft.x+3,
				globeP->phoneNumberRectangle[0].topLeft.y+1,
				&globeP->textOutlineColor);
			break;
		}
		switch (*phoneNumberP)
		{
			case '*':
				WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[10], globeP->insPtX - 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[10], globeP->insPtX + 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[10], globeP->insPtX - 1, globeP->insPtY + 1);
				WinPaintBitmap(globeP->bmpCharP[10], globeP->insPtX + 1, globeP->insPtY + 1);
				
				WinSetForeColorRGB(&globeP->textColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[10], globeP->insPtX, globeP->insPtY);
				break;
			case '#':
				WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[11], globeP->insPtX - 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[11], globeP->insPtX + 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[11], globeP->insPtX - 1, globeP->insPtY + 1);
				WinPaintBitmap(globeP->bmpCharP[11], globeP->insPtX + 1, globeP->insPtY + 1);
				
				WinSetForeColorRGB(&globeP->textColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[11], globeP->insPtX, globeP->insPtY);
				break;
			case '+':
				WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[12], globeP->insPtX - 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[12], globeP->insPtX + 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[12], globeP->insPtX - 1, globeP->insPtY + 1);
				WinPaintBitmap(globeP->bmpCharP[12], globeP->insPtX + 1, globeP->insPtY + 1);
				
				WinSetForeColorRGB(&globeP->textColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[12], globeP->insPtX, globeP->insPtY);
				break;
			case '-':
				WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[13], globeP->insPtX - 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[13], globeP->insPtX + 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[13], globeP->insPtX - 1, globeP->insPtY + 1);
				WinPaintBitmap(globeP->bmpCharP[13], globeP->insPtX + 1, globeP->insPtY + 1);
				
				WinSetForeColorRGB(&globeP->textColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[13], globeP->insPtX, globeP->insPtY);
				break;
			default:
				WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
				n = (UInt8)(*phoneNumberP) - 48;
				WinPaintBitmap(globeP->bmpCharP[n], globeP->insPtX - 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[n], globeP->insPtX + 1, globeP->insPtY - 1);
				WinPaintBitmap(globeP->bmpCharP[n], globeP->insPtX - 1, globeP->insPtY + 1);
				WinPaintBitmap(globeP->bmpCharP[n], globeP->insPtX + 1, globeP->insPtY + 1);
				
				WinSetForeColorRGB(&globeP->textColor, NULL);
				WinPaintBitmap(globeP->bmpCharP[n], globeP->insPtX, globeP->insPtY);
				break;
		}
		phoneNumberP ++;
		
		globeP->insPtX += 28;
	}
	
	//λ
	if (globeP->insPtY > maxY)
	{
		globeP->insPtX = 157;
		globeP->insPtY = maxY / 2;
	}
	else
	{
		globeP->insPtX /= 2;
		globeP->insPtY /= 2;
	}
	
	WinSetCoordinateSystem(kCoordinatesStandard);
	
	for (i = 0; i < 14; i ++)
	{
		MemHandleUnlock(bmpH[i]);
		DmReleaseResource(bmpH[i]);
	}
	
	DmCloseDatabase(dbRef);
}

static void tableDrawContactsItem(void *tableP, Int16 row, Int16 column, RectangleType *boundsP)
{
	GlobeType		*globeP = (GlobeType *)TblGetItemPtr((TableType *)tableP, 0, 0);
	
	if (globeP->fieldMappingCount > 0)
	{
		UInt16				fieldMappingIndex	= row + getScrollBarValue(globeP);
		
		if (fieldMappingIndex < globeP->fieldMappingCount)
		{
			DmOpenRef			dbRef			= DmOpenDatabaseByTypeCreator('DATA', 'PAdd', dmModeReadOnly);
			
			if (DmGetLastErr() == errNone)
			{
				MemHandle			recordH;
				
				//ȡ¼
				MemSet(globeP->contactUnitP, sizeof(AddrDBRecordType), 0);
				if (AddrDBGetRecord(dbRef, globeP->fieldMappingP[fieldMappingIndex].recordId, globeP->contactUnitP, &recordH) == errNone)
				{
					RGBColorType		originalColor;
					
					if (recordH)
					{
						MemHandleUnlock(recordH);
					}
					
					if (globeP->fieldMappingP[fieldMappingIndex].field == 0)	//
					{
						getFullname(globeP->contactUnitP, globeP->cacheP, true);
						if (globeP->fieldMappingP[fieldMappingIndex].matchType == MATCH_TYPE_NAME)
						{
							RGBColorType		highlightColor	= {0, 194, 213, 243};
							
							WinSetBackColorRGB(&highlightColor, &originalColor);
							
							WinDrawTruncChars(globeP->cacheP, StrLen(globeP->cacheP), boundsP->topLeft.x + 1, boundsP->topLeft.y, boundsP->extent.x);
							
							WinSetBackColorRGB(&originalColor, NULL);
						}
						else
						{
							WinDrawTruncChars(globeP->cacheP, StrLen(globeP->cacheP), boundsP->topLeft.x + 1, boundsP->topLeft.y, boundsP->extent.x);
						}
						MemSet(globeP->cacheP, 128, 0);
					}
					else	//
					{
						UInt16		fieldLength;
						UInt16		fieldWidth;
						
						fieldLength = StrLen(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field]);
						fieldWidth = FntCharsWidth(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field], fieldLength);
						
						if (globeP->fieldMappingP[fieldMappingIndex].matchType == MATCH_TYPE_PHONE)
						{
							RGBColorType		highlightColor;
							
							if (row == globeP->selectedRow)
							{
								highlightColor.r = 106; highlightColor.g = 43; highlightColor.b = 90;
							}
							else
							{
								highlightColor.r = 255; highlightColor.g = 213; highlightColor.b = 227;
							}
							
							WinSetBackColorRGB(&highlightColor, &originalColor);
							
							if (fieldWidth <= boundsP->extent.x - 6)
							{
								WinDrawChars(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field], fieldLength, boundsP->topLeft.x + boundsP->extent.x - fieldWidth - 10, boundsP->topLeft.y);
							}
							else
							{
								WinDrawTruncChars(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field], fieldLength, boundsP->topLeft.x + 5, boundsP->topLeft.y, boundsP->extent.x - 10);
							}
							
							WinSetBackColorRGB(&originalColor, NULL);
						}
						else
						{
							if (fieldWidth <= boundsP->extent.x - 6)
							{
								WinDrawChars(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field], fieldLength, boundsP->topLeft.x + boundsP->extent.x - fieldWidth - 10, boundsP->topLeft.y);
							}
							else
							{
								WinDrawTruncChars(globeP->contactUnitP->fields[globeP->fieldMappingP[fieldMappingIndex].field], fieldLength, boundsP->topLeft.x + 5, boundsP->topLeft.y, boundsP->extent.x - 10);
							}
						}
						
						//绰ǩ
						getPhoneLabelText(GetPhoneLabel(globeP->contactUnitP, globeP->fieldMappingP[fieldMappingIndex].field), globeP->cacheP, false);
						WinDrawChar(globeP->cacheP[0], boundsP->topLeft.x + boundsP->extent.x - (10 + FntCharWidth(globeP->cacheP[0])) / 2, boundsP->topLeft.y);
						
						globeP->cacheP[0] = 0;
					}
				}
				
				DmCloseDatabase(dbRef);
			}
		}
	}
	/*else if (row == 0)
	{
		WinDrawChars(STRING_NO_RECORDS, StrLen(STRING_NO_RECORDS), boundsP->topLeft.x + 1, boundsP->topLeft.y + 1);
	}*/
}

//ͨѶ¼б
static void tableDrawCallLogItem(void *tableP, Int16 row, Int16 column, RectangleType *boundsP)
{
	GlobeType		*globeP = (GlobeType *)TblGetItemPtr((TableType *)tableP, 0, 0);
	
	if(row + getScrollBarValue(globeP) >= globeP->callLogCount)
			return;
	if (globeP->callLogCount > 0)
	{
		DmOpenRef		dbRef	= DmOpenDatabaseByTypeCreator('call', 'HsPh', dmModeReadOnly);
		
		
		if (DmGetLastErr() == errNone)
		{
			UInt16				attribute;
			DateType			today;
			UInt16				itemNum			= row + getScrollBarValue(globeP);
			MemHandle			recordH			= DmQueryRecord(dbRef, globeP->callLogListP[itemNum].recordId);
			PhoneCallDBType		*recordP		= MemHandleLock(recordH);
			
			//ʾ
			DmRecordInfo(dbRef, globeP->callLogListP[itemNum].recordId, &attribute, NULL, NULL);
			WinDrawBitmap(globeP->bmpP[(UInt8)(attribute & dmRecAttrCategoryMask) - 1], boundsP->topLeft.x, boundsP->topLeft.y + 1);
			
			//ʾ
			if ((UInt8)recordP->nameString[0] == 0)
			{
				WinDrawTruncChars((recordP->nameString + 1), StrLen((recordP->nameString + 1)), boundsP->topLeft.x + 10, boundsP->topLeft.y, 89);
			}
			else
			{
				WinDrawTruncChars(recordP->nameString, StrLen(recordP->nameString), boundsP->topLeft.x + 10, boundsP->topLeft.y, 89);
			}
			
			//ʾڻʱ
			DateSecondsToDate(TimGetSeconds(), &today);
			if (DateToInt(recordP->date) == DateToInt(today))	//ʾʱ
			{
				TimeToAscii(recordP->time.hours, recordP->time.minutes, tfColon24h, globeP->cacheP);
			}
			else	//ʾڣڴ1904ʼ
			{
				DateTemplateToAscii("^1r ^3s-^0s", recordP->date.month, recordP->date.day, recordP->date.year + 1904, globeP->cacheP, 128);
			}
			WinDrawChars(globeP->cacheP, StrLen(globeP->cacheP), 106, boundsP->topLeft.y);
			MemSet(globeP->cacheP, 128, 0);
			
			//
			WinDrawGrayLine(103, boundsP->topLeft.y, 103, boundsP->topLeft.y + 11);
			
			MemHandleUnlock(recordH);
			DmCloseDatabase(dbRef);
		}
	}
	else if (row == 0)
	{
		WinDrawChars(STRING_NO_RECORDS, StrLen(STRING_NO_RECORDS), boundsP->topLeft.x + 1, boundsP->topLeft.y + 1);
	}
}

//ʾʱ
static void drawPhoneUIDatetimeBar(GlobeType *globeP)
{
	UInt16			n, stringLength;
	DateTimeType	now;
	MemHandle		bmpH;
	Char			*contentP;
	DmOpenRef		dbRef				= DmOpenDatabaseByTypeCreator('NlPh', APPLICATION_CREATOR, dmModeReadOnly);
	
	//ȡǰʱ
	TimSecondsToDateTime(TimGetSeconds(), &now);
	
	//ȡʱ
	TimeToAscii(now.hour, now.minute, tfColon24h, globeP->timeStringP);
	stringLength = StrLen(globeP->timeStringP);
	
	bmpH = DmGet1Resource('Tbmp', bmpTriger);
	globeP->bmpTrigerP = (BitmapType *)MemHandleLock(bmpH);
	
	switch (globeP->contentType)
	{
		case CONTENT_TYPE_CALL_LOG:
			contentP = STRING_CALL_LOG;
			break;
		case CONTENT_TYPE_CONTACTS:
			contentP = STRING_CONTACTS;
			break;
		case CONTENT_TYPE_DIAL_PAD:
			contentP = STRING_DIAL_PAD;
			break;
	}
	WinSetForeColorRGB(&globeP->foreColor, NULL);
	FntSetFont(boldFont);
	if (globeP->defaultDisplayEffect == DISPLAY_EFFECT_ADD_MASK)
	{
		WinPaintRectangle(&globeP->datetimeBarRectangle, 0);
		
		//ʱ
		WinSetTextColorRGB(&globeP->backgdColor, NULL);
		WinPaintChars(globeP->timeStringP, stringLength, 158 - FntCharsWidth(globeP->timeStringP, stringLength), 1);
		
		//
		WinSetForeColorRGB(&globeP->backgdColor, NULL);
		WinPaintBitmap(globeP->bmpTrigerP, 2, 2);
		
		//
		WinPaintChars(contentP, StrLen(contentP), 20, 1);
	}
	else
	{
		if (globeP->defaultDisplayEffect == DISPLAY_EFFECT_ADD_LINE)
		{
			WinPaintLine(0, 13, 159, 13);
			//WinPaintLine(0, 27, 159, 27);
		}
		
		n = (158 - FntCharsWidth(globeP->timeStringP, stringLength)) * 2;
		
		WinSetCoordinateSystem(kCoordinatesDouble);
		
		//
		WinSetForeColorRGB(&globeP->textOutlineColor, NULL);
		WinPaintBitmap(globeP->bmpTrigerP, 3, 3);
		WinPaintBitmap(globeP->bmpTrigerP, 5, 5);
		WinPaintBitmap(globeP->bmpTrigerP, 3, 5);
		WinPaintBitmap(globeP->bmpTrigerP, 5, 3);
		WinSetForeColorRGB(&globeP->textColor, NULL);
		WinPaintBitmap(globeP->bmpTrigerP, 4, 4);
		
		//
		WinSetTextColorRGB(&globeP->textOutlineColor, NULL);
		WinPaintChars(contentP, StrLen(contentP), 39, 0);
		WinPaintChars(contentP, StrLen(contentP), 41, 2);
		WinPaintChars(contentP, StrLen(contentP), 39,2);
		WinPaintChars(contentP, StrLen(contentP), 41, 0);
		WinPaintChars(globeP->timeStringP, stringLength, n - 1, 0);
		WinPaintChars(globeP->timeStringP, stringLength, n + 1,2);
		WinPaintChars(globeP->timeStringP, stringLength, n - 1, 2);
		WinPaintChars(globeP->timeStringP, stringLength, n + 1, 0);
		WinSetTextColorRGB(&globeP->textColor, NULL);
		WinPaintChars(contentP, StrLen(contentP), 40, 1);
		WinPaintChars(globeP->timeStringP, stringLength, n, 1);
		
		WinSetCoordinateSystem(kCoordinatesStandard);
	}
	FntSetFont(stdFont);
	
	MemHandleUnlock(bmpH);
	DmReleaseResource(bmpH);
	DmCloseDatabase(dbRef);
}

//״̬
static void drawPhoneUIStatusBar(GlobeType *globeP)
{
	//״̬
	WinSetBackColorRGB(&globeP->backgdColor, NULL);
	WinEraseRectangle(&globeP->statusBarRectangle, 0);
	
	//־
	WinSetTextColorRGB(&globeP->textColor, NULL);
	FntSetFont(boldFont);
	paintCharsWithOutline(globeP->operatorNameP, StrLen(globeP->operatorNameP), 1, 1, &globeP->textOutlineColor);
	FntSetFont(stdFont);
	
	//Gadget
	PmSysGadgetStatusGadgetsUpdate(globeP->pmGadgetLibRef);
}

//
static void drawPhoneUIContent(GlobeType *globeP, Boolean shouldRefresh)
{
	WinSetForeColorRGB(&globeP->foreColor, NULL);
	WinSetBackColorRGB(&globeP->backgdColor, NULL);
	WinSetTextColorRGB(&globeP->textColor, NULL);
	
	if (shouldRefresh)
	{
		switch (globeP->contentType)
		{
			case CONTENT_TYPE_CALL_LOG:
				WinEraseRectangle(&globeP->listBarRectangle, 2);
				WinPaintRectangleFrame(dialogFrame, &globeP->listBarRectangle);
			
				break;
			case CONTENT_TYPE_CONTACTS:
				WinEraseRectangle(&globeP->listBarRectangle, 2);
				WinPaintRectangleFrame(dialogFrame, &globeP->listBarRectangle);
				FntSetFont(boldFont);
				if (globeP->contactSearchKeywordLength > 0)
				{
					WinDrawTruncChars(globeP->contactSearchKeywordP, globeP->contactSearchKeywordLength, 66, 0, 60);
				}
				FntSetFont(stdFont);
				break;
			case CONTENT_TYPE_DIAL_PAD:
				WinEraseRectangle(&globeP->dialPadRectangle, 2);
				WinPaintRectangleFrame(dialogFrame, &globeP->dialPadRectangle);
				break;
		}
	}
	
	drawPhoneNumber(globeP->phoneNumberP, globeP);
}

//ƽ
static void drawPhonePad(GlobeType *globeP, UInt16 updateCode)
{
	UInt16		i;
	
	
	switch (updateCode)
	{
		case frmRedrawUpdateCode:
			WinSetDrawWindow(globeP->offscreenWindowH);
			WinEraseWindow();
			if (globeP->bmpBackgroundP)
			{
				WinDrawBitmap((BitmapType *)globeP->bmpBackgroundP, 0, 0);
			}
			drawPhoneUIDatetimeBar(globeP);
			drawPhoneUIContent(globeP, true);
			WinSetDrawWindow((WinHandle)globeP->frmPhoneUIP);
			WinCopyRectangle(globeP->offscreenWindowH, (WinHandle)globeP->frmPhoneUIP, &globeP->backgdRectangle, 0, 0, winPaint);
			//drawPhoneUIStatusBar(globeP);
			
			if (globeP->contentType != CONTENT_TYPE_DIAL_PAD)
			{
				//CtlDrawControl(globeP->ptriPhoneCategoryListP);
				TblDrawTable(globeP->tblPhoneListP);
				if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount >= TABLE_ROWS_NUMS) ||
					(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount >= TABLE_ROWS_NUMS))
				{
					SclDrawScrollBar(globeP->sclPhoneListP);
				}
				CtlDrawControl(globeP->btnPhoneDialP);
				CtlDrawControl(globeP->btnPhoneContactP);
				CtlDrawControl(globeP->btnPhoneTextP);				
				CtlDrawControl(globeP->btnPhoneClearP);
				CtlDrawControl(globeP->btnPhoneCancelP);
				if (globeP->selectedRow != -1)
				{
					TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
				}
			}
			else
			{
				for (i = 0; i < 12; i ++)
				{
					CtlDrawControl(globeP->btnPhoneButtonsP[i]);
				}
				CtlDrawControl(globeP->btnPhoneDialP);
				CtlDrawControl(globeP->btnPhoneContactP);
				CtlDrawControl(globeP->btnPhoneTextP);				
				CtlDrawControl(globeP->btnPhoneClearP);
				CtlDrawControl(globeP->btnPhoneCancelP);
			}
			break;
		case FORM_UPDATE_CONTENT:
			WinSetDrawWindow(globeP->offscreenWindowH);
			
			WinEraseWindow();
			if (globeP->bmpBackgroundP)
			{
				WinDrawBitmap((BitmapType *)globeP->bmpBackgroundP, 0, 0);
			}
			drawPhoneUIDatetimeBar(globeP);
			drawPhoneUIContent(globeP, true);
			WinSetDrawWindow((WinHandle)globeP->frmPhoneUIP);
			WinCopyRectangle(globeP->offscreenWindowH, (WinHandle)globeP->frmPhoneUIP, &globeP->backgdRectangle, 0, 0, winPaint);
			
			if (globeP->contentType != CONTENT_TYPE_DIAL_PAD)
			{
				//CtlDrawControl(globeP->ptriPhoneCategoryListP);
				TblDrawTable(globeP->tblPhoneListP);
				if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount >= TABLE_ROWS_NUMS) ||
					(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount >= TABLE_ROWS_NUMS))
				{
					SclDrawScrollBar(globeP->sclPhoneListP);
				}
				CtlDrawControl(globeP->btnPhoneDialP);
				CtlDrawControl(globeP->btnPhoneContactP);
				CtlDrawControl(globeP->btnPhoneTextP);				
				CtlDrawControl(globeP->btnPhoneClearP);
				CtlDrawControl(globeP->btnPhoneCancelP);
				if (globeP->selectedRow != -1)
				{
					TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
				}
			}
			else
			{
				for (i = 0; i < 12; i ++)
				{
					CtlDrawControl(globeP->btnPhoneButtonsP[i]);
				}
				CtlDrawControl(globeP->btnPhoneDialP);
				CtlDrawControl(globeP->btnPhoneContactP);
				CtlDrawControl(globeP->btnPhoneTextP);				
				CtlDrawControl(globeP->btnPhoneClearP);
				CtlDrawControl(globeP->btnPhoneCancelP);
			}
			break;
		case FORM_UPDATE_PHONE_NUMBER:
			WinSetDrawWindow(globeP->offscreenWindowH);
			WinEraseWindow();
			if (globeP->bmpBackgroundP)
			{
				WinDrawBitmap((BitmapType *)globeP->bmpBackgroundP, 0, 0);
			}
			drawPhoneUIContent(globeP, false);
			WinSetDrawWindow((WinHandle)globeP->frmPhoneUIP);
			WinCopyRectangle(globeP->offscreenWindowH, (WinHandle)globeP->frmPhoneUIP,
				 &globeP->phoneNumberRectangle[0],globeP->phoneNumberRectangle[0].topLeft.x,
				 globeP->phoneNumberRectangle[0].topLeft.y, winPaint);
			
			break;
	}
	
	if (globeP->focusedObjectId == gdtContentType)
	{
		HsNavDrawFocusRing(globeP->frmPhoneUIP, globeP->focusedObjectId, hsNavFocusRingNoExtraInfo, &globeP->tabRectangle, hsNavFocusRingStyleSquare, true);
	}
}

#if 0
#pragma mark == PHONE EVENT HANDLE FUNCTIONS ==
#endif

//ͨѶ¼
static void purgeCallLog(GlobeType *globeP)
{
	FormType			*frmPurgeCallLogP;
	ControlType			*ptriPurgeTimeP;
	ListType			*lstPurgeTimeP;
	EventType			event;
	DmOpenRef			dbRef;
	MemHandle			recordH;
	PhoneCallDBType		*recordP;
	Int32				i;
	UInt16				recordNums;
	Boolean				isEventHandled;
	Boolean				shouldExit			= false;
	
	FrmPopupForm(frmPurgeCallLog);
	
	do
	{
		EvtGetEvent(&event, evtWaitForever);
		isEventHandled = false;
		
		if (! SysHandleEvent(&event))
		{
			switch (event.eType)
			{
				case frmLoadEvent:
					if (event.data.frmLoad.formID == frmPurgeCallLog)
					{
						frmPurgeCallLogP = FrmInitForm(frmPurgeCallLog);
						ptriPurgeTimeP = (ControlType *)GET_OBJECT_POINTER(frmPurgeCallLogP, ptriPurgeTime);
						lstPurgeTimeP = (ListType *)GET_OBJECT_POINTER(frmPurgeCallLogP, lstPurgeTime);
						
						FrmSetActiveForm(frmPurgeCallLogP);
						
						isEventHandled = true;
					}
					break;
				case frmOpenEvent:
					if (event.data.frmOpen.formID == frmPurgeCallLog)
					{
						LstSetSelection(lstPurgeTimeP, 0);
						CtlSetLabel(ptriPurgeTimeP, LstGetSelectionText(lstPurgeTimeP, 0));
						
						FrmDrawForm(frmPurgeCallLogP);
						
						isEventHandled = true;
					}
					break;
				case ctlSelectEvent:
					if (event.data.ctlSelect.controlID == btnPurgeCancel)
					{
						shouldExit = true;
						isEventHandled = true;
					}
					else if (event.data.ctlSelect.controlID == btnPurge)
					{
						UInt32			recordDays;
						UInt32			outdateDays;
						DateType		today;
						UInt8			leftRecordNums;
						Boolean			shouldPurgeByTime	= true;
						
						DateSecondsToDate(TimGetSeconds(), &today);
						outdateDays = DateToDays(today);
						switch(LstGetSelection(lstPurgeTimeP))
						{
							case 0:		//һǰ
								outdateDays -= 7;
								break;
							case 1:		//һǰ
								outdateDays -= DaysInMonth(today.month, today.year);
								break;
							case 2:		//ǰ
								outdateDays -= DaysInMonth(today.month, today.year);
								if (today.month > 1)
								{
									today.month --;
								}
								else
								{
									today.month = 12;
									today.year --;
								}
								outdateDays -= DaysInMonth(today.month, today.year);
								outdateDays;
								break;
							case 3:		//ʮμ¼
								shouldPurgeByTime = false;
								leftRecordNums = 10;
								break;
							case 4:		//ȫ
								shouldPurgeByTime = false;
								leftRecordNums = 0;
								break;
						}
						
						dbRef = DmOpenDatabaseByTypeCreator('call', 'HsPh', dmModeReadWrite);
						recordNums = DmNumRecordsInCategory(dbRef, dmAllCategories);
						
						if (shouldPurgeByTime)
						{
							for (i = 0; i < recordNums; i ++)
							{
								recordH = DmQueryRecord(dbRef, i);
								recordP = (PhoneCallDBType *)MemHandleLock(recordH);
								
								recordDays = DateToDays(recordP->date);
								
								MemHandleUnlock(recordH);
								
								if (recordDays < outdateDays)
								{
									DmRemoveRecord(dbRef, i);
									i --;
									recordNums --;
								}
							}
						}
						else
						{
							for (i = recordNums - 1; i >= leftRecordNums ; i --)
							{
								DmRemoveRecord(dbRef, i);
							}
						}
						
						DmCloseDatabase(dbRef);
						shouldExit = true;
						isEventHandled = true;
					}
					break;
			}
			
			if (! isEventHandled)
			{
				FrmDispatchEvent(&event);
			}
		}
	}while(event.eType != appStopEvent && shouldExit == false);
	
	freeCallLog(globeP);
	if (globeP->contentType == CONTENT_TYPE_CALL_LOG)
	{
		getCallLog(globeP);
		//globeP->callLogCategory = CALL_LOG_CATEGORY_ALL;
		//globeP->setTableContent = SET_TABLE_CONTENT_CALL_LOG;
		//FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
	}
	
	FrmReturnToForm(0);
}

//
static void savePhoneNumber(Char *phoneNumberP, Int16 target, GlobeType *globeP)
{
	AddrCreateNewRecordParamsType	*addContactParameterP	= (AddrCreateNewRecordParamsType *)MemPtrNew(sizeof(AddrCreateNewRecordParamsType));
	SysNotifyParamType				*notifyParamP			= (SysNotifyParamType *)MemPtrNew(sizeof(SysNotifyParamType));
	
	//ò
	addContactParameterP->data = (Char *)MemPtrNew(StrLen(phoneNumberP) + 1);
	StrCopy(addContactParameterP->data, phoneNumberP);
	MemPtrSetOwner(addContactParameterP->data, 0);
	MemPtrSetOwner(addContactParameterP, 0);
	notifyParamP->notifyType = addrAppNotificationCreateNewRecord;
	notifyParamP->broadcaster = APPLICATION_CREATOR;
	notifyParamP->notifyDetailsP = addContactParameterP;
	notifyParamP->handled = false;
	MemPtrSetOwner(notifyParamP, 0);
	
	//ͨѶ¼
	addContactParameterP->field = 4;
	
	LaunchWithCommand('appl', 'PAdd', sysAppLaunchCmdNotify, notifyParamP);
}

//ϵ
static void openPhoneContact(Char *phoneNumberP, Int16 target, GlobeType *globeP)
{
	UInt16	recordId = 0;
	
	globeP->cacheP[0] = '\0';
	//ȡϵ
	if (searchContactByPhoneNumber(&recordId, globeP->cacheP, phoneNumberP, StrLen(phoneNumberP), globeP))	//
	{
		UInt16				cardNo;
		LocalID				dbId;
		DmSearchStateType	dmSearchState;
		GoToParamsType		*gotoParameterP	= (GoToParamsType *)MemPtrNew(sizeof(GoToParamsType));
		
		//ò
		MemSet(gotoParameterP, sizeof(GoToParamsType), 0x00);
		MemPtrSetOwner(gotoParameterP, 0);
		gotoParameterP->recordNum = recordId - 1;	//0ʼ
		
		//ͨѶ¼
		if (DmGetNextDatabaseByTypeCreator(true, &dmSearchState, 'DATA', 'PAdd', true, &cardNo, &dbId) == errNone)
		{
			gotoParameterP->dbID = dbId;
			LaunchWithCommand('appl', 'PAdd', sysAppLaunchCmdGoTo, gotoParameterP);
		}
	}
}

//
static void sendPhoneText(Char *phoneNumber, Int16 target, GlobeType *globeP)
{
	UInt16	recordId 		= 0;
	Boolean	hasName			= false;
	Char	*phoneNumberP 	= NULL;
	Char	*nameP 			= NULL;

	if (phoneNumber != NULL)	
	{
		//ȡϵ
		globeP->cacheP[0] = '\0';
		hasName = searchContactByPhoneNumber(&recordId, globeP->cacheP, phoneNumber, StrLen(phoneNumber), globeP);	//
	}
		
	if (hasName)
	{
		nameP = (Char *)MemPtrNew(StrLen(globeP->cacheP) + 1);
		StrCopy(nameP, globeP->cacheP);
		MemPtrSetOwner(nameP, 0);
	}
	
	if (phoneNumber != NULL)		
	{
		phoneNumberP = (Char *)MemPtrNew(StrLen(phoneNumber) + 1);
		StrCopy(phoneNumberP, phoneNumber);
		MemPtrSetOwner(phoneNumberP, 0);
	}	

	//öѶ
	HsCreateNewMessage(phoneNumberP, nameP, NULL);
}

//
static Boolean dialCall(Char *phoneNumberP, Int16 dialType, GlobeType *globeP)
{
	if (dialType >= 0)
	{
		SysNotifyParamType		*paramP				= (SysNotifyParamType *)MemPtrNew(sizeof(SysNotifyParamType));
		HelperNotifyEventType	*detailsP			= (HelperNotifyEventType *)MemPtrNew(sizeof(HelperNotifyEventType));
		HelperNotifyExecuteType	*executeP			= (HelperNotifyExecuteType *)MemPtrNew(sizeof(HelperNotifyExecuteType));
		UInt16					phoneNumberLength	= StrLen(phoneNumberP);
		UInt16					recordId;
		
		//ʼ
		MemSet(paramP, sizeof(SysNotifyParamType), 0);
		MemSet(detailsP, sizeof(HelperNotifyEventType), 0);
		MemSet(executeP, sizeof(HelperNotifyExecuteType), 0);
		
		paramP->notifyType = sysNotifyHelperEvent;
		paramP->broadcaster = APPLICATION_CREATOR;
		paramP->notifyDetailsP = detailsP;
		paramP->handled = false;

		detailsP->version = kHelperNotifyCurrentVersion;
		detailsP->actionCode = kHelperNotifyActionCodeExecute;
		detailsP->data.executeP = executeP;

		executeP->serviceClassID = kHelperServiceClassIDVoiceDial;
		executeP->helperAppID = 0;
		executeP->detailsP = 0;
		executeP->err = errNone;
		
		//ȡϵ
		if (searchContactByPhoneNumber(&recordId, globeP->cacheP, phoneNumberP, phoneNumberLength, globeP))	//
		{
			executeP->displayedName = (Char *)MemPtrNew(StrLen(globeP->cacheP) + 1);
			StrCopy(executeP->displayedName, globeP->cacheP);
			MemPtrSetOwner(executeP->displayedName, 0);
		}
		
		//
		if (dialType == 0)		//ֱ
		{
			executeP->dataP = (Char *)MemPtrNew(phoneNumberLength + 1);
			StrCopy(executeP->dataP, phoneNumberP);
		}
		else
		{
			executeP->dataP = (Char *)MemPtrNew(phoneNumberLength + StrLen(globeP->callCardsPP[dialType]));	//1Ϊ绰ĵһλǡ+Ҫȥ
			StrCopy(executeP->dataP, (globeP->callCardsPP[dialType] + 1));
			StrCat(executeP->dataP, phoneNumberP);
		}
		
		MemPtrSetOwner(executeP->dataP, 0);
		MemPtrSetOwner(executeP, 0);
		MemPtrSetOwner(detailsP, 0);
		MemPtrSetOwner(paramP, 0);
		
		SysNotifyBroadcast(paramP);
		
		return true;
	}
	
	return false;
}

//ȡһԱѡ
static Boolean getNextSelectableRow(GlobeType *globeP)
{
	Int16		value, min, max, pageSize;
	Boolean		success		= true;
	
	SclGetScrollBar(globeP->sclPhoneListP, &value, &min, &max, &pageSize);
	
	switch(globeP->contentType)
	{
		case CONTENT_TYPE_CALL_LOG:
			if (globeP->selectedRow == -1 && globeP->callLogCount > 0)
			{
				globeP->selectedRow = 0;
			}
			else
			{
				if (globeP->selectedRow + value < globeP->callLogCount - 1)
				{
					globeP->selectedRow ++;
					
					if (globeP->selectedRow > TABLE_ROWS_NUMS - 1)
					{
						globeP->selectedRow = 0;
						
						value += pageSize;
						
						if (value > max)
						{
							value = max;
						}
						
						SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
						TblDrawTable(globeP->tblPhoneListP);
					}
				}
				else
				{
					success = false;
				}
			}
			break;
		case CONTENT_TYPE_CONTACTS:
			if (globeP->selectedRow == -1 && globeP->fieldMappingCount > 0)
			{
				globeP->selectedRow = 1;
			}
			else
			{
				if (globeP->selectedRow + value < globeP->fieldMappingCount - 1)
				{
					globeP->selectedRow ++;
					
					if (globeP->selectedRow > TABLE_ROWS_NUMS - 1)
					{
						globeP->selectedRow = 0;
						
						value += pageSize;
						
						if (value > max)
						{
							value = max;
						}
						
						SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
						TblDrawTable(globeP->tblPhoneListP);
					}
				}
				else
				{
					success = false;
				}
			}
			
			if (success)
			{
				if (globeP->fieldMappingP[globeP->selectedRow + value].field == 0)
				{
					if (globeP->selectedRow > TABLE_ROWS_NUMS - 2)
					{
						value += pageSize;
						
						if (value > max)
						{
							value = max;
						}
						
						globeP->selectedRow = 0;
						if (globeP->fieldMappingP[globeP->selectedRow + value].field == 0)
						{
							globeP->selectedRow = 1;
						}
						
						SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
						TblDrawTable(globeP->tblPhoneListP);
					}
					else
					{
						globeP->selectedRow ++;
					}
				}
			}
			break;
	}
	
	return success;
}

//ȡһԱѡ
static Boolean getPrevSelectableRow(GlobeType *globeP)
{
	Int16		value, min, max, pageSize;
	Boolean		success		= true;
	
	SclGetScrollBar(globeP->sclPhoneListP, &value, &min, &max, &pageSize);
	
	switch(globeP->contentType)
	{
		case CONTENT_TYPE_CALL_LOG:
			if (globeP->selectedRow == -1 && globeP->callLogCount > 0)
			{
				globeP->selectedRow = 0;
			}
			else
			{
				if (globeP->selectedRow > 0)
				{
					globeP->selectedRow --;
				}
				else if (value > 0)
				{
					value --;
					
					SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
					TblDrawTable(globeP->tblPhoneListP);
				}
				else
				{
					success = false;
				}
			}
			break;
		case CONTENT_TYPE_CONTACTS:
			if (globeP->selectedRow == -1 && globeP->fieldMappingCount > 0)
			{
				globeP->selectedRow = 1;
			}
			else
			{
				if (globeP->selectedRow > 0)
				{
					globeP->selectedRow --;
				}
				else if (value > 0)
				{
					value --;
					
					SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
					TblDrawTable(globeP->tblPhoneListP);
				}
				else
				{
					success = false;
				}
			}
			
			if (success)
			{
				if (globeP->fieldMappingP[globeP->selectedRow + value].field == 0)
				{
					if (globeP->selectedRow == 0 && value == 0)
					{
						success = false;
						globeP->selectedRow ++;
					}
					else if (globeP->selectedRow + value - 1 > 0)
					{
						if (globeP->selectedRow > 0)
						{
							globeP->selectedRow --;
						}
						else
						{
							value --;
						}
						
						SclSetScrollBar(globeP->sclPhoneListP, value, min, max, pageSize);
						TblDrawTable(globeP->tblPhoneListP);
					}
				}
			}
			break;
	}
	
	return success;
}

//ⱻѡǷ
static Boolean isRowCanntBeSelected(GlobeType *globeP, Int16 row)
{
	if (globeP->contentType == CONTENT_TYPE_CONTACTS)
	{
		UInt16		itemNum		= row + getScrollBarValue(globeP);
		
		if (globeP->fieldMappingCount > itemNum)
		{
			if (globeP->fieldMappingP[itemNum].field == 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return true;
		}
	}
	
	return false;
}

//ȡʶ
static void getOperatorName(GlobeType *globeP, LauncherSettingType *launcherSettingP)
{
	if (PhnLibModulePowered(globeP->hsPhoneLibRef) == phnPowerOff)
	{
		StrCopy(globeP->operatorNameP, STRING_PHONE_OFF);
	}
	else
	{
		if (launcherSettingP->useCustomCarrier)
		{
			StrCopy(globeP->operatorNameP, launcherSettingP->customCarrierP);
		}
		else
		{
			GSMRegistrationMode		gsmRegMode;
			PhnOperatorID			operatorID;
			Char					*bufferP	= NULL;
			
			PhnLibCurrentOperator(globeP->hsPhoneLibRef, &operatorID, &bufferP, &gsmRegMode);
			if (bufferP)
			{
				StrCopy(globeP->operatorNameP, bufferP);
				MemPtrFree(bufferP);
			}
		}
	}
}

/*/÷ѡ˵
static void setCategoryText(GlobeType *globeP)
{
	switch (globeP->contentType)
	{
		case CONTENT_TYPE_CALL_LOG:
			//LstSetListChoices(globeP->lstPhoneCategoryListP, globeP->callLogCategoryPP, 4);
			//LstSetHeight(globeP->lstPhoneCategoryListP, 4);
			if (globeP->callLogCategory == CALL_LOG_CATEGORY_ALL)
			{
				LstSetSelection(globeP->lstPhoneCategoryListP, 0);
			}
			else
			{
				LstSetSelection(globeP->lstPhoneCategoryListP, globeP->callLogCategory);
			}
			CtlSetLabel(globeP->ptriPhoneCategoryListP, globeP->callLogCategoryPP[LstGetSelection(globeP->lstPhoneCategoryListP)]);
			break;
		case CONTENT_TYPE_CONTACTS:
			//LstSetListChoices(globeP->lstPhoneCategoryListP, globeP->contactCategoryPP, globeP->contactCategoryCount);
			if (globeP->contactCategoryCount < 12)
			{
				LstSetHeight(globeP->lstPhoneCategoryListP, globeP->contactCategoryCount);
			}
			else
			{
				LstSetHeight(globeP->lstPhoneCategoryListP, 11);
			}
			if (globeP->contactsCategory == dmAllCategories)
			{
				LstSetSelection(globeP->lstPhoneCategoryListP, 0);
			}
			else
			{
				UInt16		i;
				
				for (i = 0; i < globeP->contactCategoryCount; i ++)
				{
					if (globeP->contactCategoryMappingP[i] == globeP->contactsCategory)
					{
						LstSetSelection(globeP->lstPhoneCategoryListP, i);
					}
				}
			}
			CtlSetLabel(globeP->ptriPhoneCategoryListP, globeP->contactCategoryPP[LstGetSelection(globeP->lstPhoneCategoryListP)]);
			break;
		case CONTENT_TYPE_DIAL_PAD:
			break;
	}
}*/

//ѡı绰
static void insertPhoneNumberFromTable(GlobeType *globeP, Int16 row)
{
	DmOpenRef		dbRef;
	MemHandle		recordH;
	void			*recordP;
	UInt16			itemNum			= row + getScrollBarValue(globeP);
	
	switch (globeP->contentType)
	{
		case CONTENT_TYPE_CALL_LOG:
			if (globeP->callLogCount > itemNum)
			{
				//ȡ¼
				dbRef = DmOpenDatabaseByTypeCreator('call', 'HsPh', dmModeReadOnly);
				recordH = DmQueryRecord(dbRef, globeP->callLogListP[itemNum].recordId);
				recordP = (PhoneCallDBType *)MemHandleLock(recordH);
				
				StrCopy(globeP->phoneNumberP, ((PhoneCallDBType *)recordP)->nameString + (StrLen(((PhoneCallDBType *)recordP)->nameString) + 1));
				
				MemHandleUnlock(recordH);
				
				DmCloseDatabase(dbRef);
			}
			break;
		case CONTENT_TYPE_CONTACTS:
			if (globeP->fieldMappingCount > itemNum)
			{
				dbRef = DmOpenDatabaseByTypeCreator('DATA', 'PAdd', dmModeReadOnly);
				
				if (AddrDBGetRecord(dbRef, globeP->fieldMappingP[itemNum].recordId, globeP->contactUnitP, &recordH) == errNone)
				{
					if (recordH)
					{
						MemHandleUnlock(recordH);
					}
					
					if (globeP->fieldMappingP[itemNum].field != 0)
					{
						StrDigitCopy(globeP->phoneNumberP, globeP->contactUnitP->fields[globeP->fieldMappingP[itemNum].field]);
						MemSet(globeP->cacheP, 128, 0);
					}
				}
				
				DmCloseDatabase(dbRef);
			}
			break;
	}
}

//ֵת
static WChar keyTransfer(EventType *eventP)
{
	if (eventP->data.keyDown.modifiers & 0x0008)
	{
		if (eventP->data.keyDown.keyCode != 0)
		{
			return (WChar)eventP->data.keyDown.keyCode;
		}
		else
		{
			return eventP->data.keyDown.chr;
		}
	}
	else
	{
		return eventP->data.keyDown.chr;
	}
}

//绰绰¼
static Boolean frmPhoneUICustomEventHandler(EventType *eventP, GlobeType *globeP, LauncherSettingType *launcherSettingP)
{
	Boolean			isCustomEventHandled	= false;
	
	switch (eventP->eType)
	{
		case PHONE_EVENT_NETWORK_SEARCHING:
			StrCopy(globeP->operatorNameP, STRING_NETWORK_SEARCHING);
			isCustomEventHandled = true;
			break;
		case PHONE_EVENT_POWER_ON:
			StrCopy(globeP->operatorNameP, STRING_PHONE_ON);
			isCustomEventHandled = true;
			break;
		case PHONE_EVENT_POWER_OFF:
			StrCopy(globeP->operatorNameP, STRING_PHONE_OFF);
			isCustomEventHandled = true;
			break;
		case PHONE_EVENT_HOME:
			getOperatorName(globeP, launcherSettingP);
			isCustomEventHandled = true;
			break;
		case PHONE_EVENT_OTHER:
			isCustomEventHandled = true;
			break;
		case NOTIFY_EVENT_DB:
			isCustomEventHandled = true;
			break;
		case NOTIFY_EVENT_CARD_MOUNT:
			isCustomEventHandled = true;
			break;
		case NOTIFY_EVENT_CARD_UNMOUNT:
			isCustomEventHandled = true;
			break;
	}
	
	if (isCustomEventHandled)
	{
		FrmUpdateForm(frmPhoneUI, FORM_UPDATE_STATUS_BAR_ONLY);
	}
	
	return isCustomEventHandled;
}

//ѡ¼
static void enqueueGadgetSelectEvent(UInt16 gadgetId)
{
	EventType		event;
	
	MemSet(&event, sizeof(EventType), 0);
	
	event.eType = penDownEvent;
	event.penDown = true;
	event.tapCount = 1;
	event.screenX = 3;
	event.screenY = 8;
	
	/*switch (gadgetId)
	{
		case gdtCallLogTab:
			event.screenX = 8;
			break;
		case gdtContactTab:
			event.screenX = 30;
			break;
		case gdtDialPadTab:
			event.screenX = 52;
			break;
	}*/
	
	EvtAddUniqueEventToQueue(&event, 0, false);
}

//ɱѡ¼
static void enqueueTableSelectEvent(GlobeType *globeP)
{
	EventType		event;
	
	MemSet(&event, sizeof(EventType), 0);
	
	event.eType = tblSelectEvent;
	event.data.tblSelect.tableID = tblPhoneList;
	event.data.tblSelect.pTable = globeP->tblPhoneListP;
	event.data.tblSelect.row = globeP->selectedRow;
	event.data.tblSelect.column = 0;
	
	EvtAddUniqueEventToQueue(&event, 0, false);
}

//¼
static Boolean phoneKeyEventHandler(EventType *eventP, UInt8 *actionTypeP, GlobeType *globeP)
{
	Boolean			isKeyHandled		= false;
	Boolean			shouldChangeFocus	= false;
	
	if (eventP->eType == keyDownEvent && (! globeP->isMenuActived))
	{
		WChar		chr	= keyTransfer(eventP);
		
		switch (chr)
		{
			case chrUpArrow:		//
			case vchrPageUp:
			case vchrRockerUp:
				switch (globeP->focusedObjectId)
				{
					case btnPhoneDial:
					case btnPhoneContact:
					case btnPhoneText:
					case btnPhoneClear:
					case btnPhoneCancel:
						if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
						{
							if (globeP->selectedRow == -1)
							{
								if (getNextSelectableRow(globeP))
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
								}
								else
								{
									globeP->focusedObjectId = gdtPhoneNumber;
									
								}
							}
							else
							{
								globeP->focusedObjectId = tblPhoneList;
								enqueueTableSelectEvent(globeP);
							}
						}
						else
						{
							
								globeP->focusedObjectId = gdtPhoneNumber;
							
						}
						shouldChangeFocus = true;
						break;
					/*case ptriPhoneCategoryList:
						globeP->focusedObjectId = gdtPhoneNumber;
						shouldChangeFocus = true;
						break;
						*/
					case gdtPhoneNumber:
						globeP->focusedObjectId = gdtContentType;
						globeP->shouldEraseInsPt = true;
						shouldChangeFocus = true;
						break;
					case tblPhoneList:
						if (! getPrevSelectableRow(globeP))
						{
							TblUnhighlightSelection(globeP->tblPhoneListP);
							globeP->focusedObjectId = gdtPhoneNumber;
							shouldChangeFocus = true;
						}
						else
						{
							TblUnhighlightSelection(globeP->tblPhoneListP);
							TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
							enqueueTableSelectEvent(globeP);
						}
						break;
				}
				isKeyHandled = true;
				break;
			case chrDownArrow:		//
			case vchrPageDown:
			case vchrRockerDown:
				switch (globeP->focusedObjectId)
				{
					case gdtContentType:
						globeP->focusedObjectId = gdtPhoneNumber;
						shouldChangeFocus = true;
						break;
					case gdtPhoneNumber:
						if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
						{
							if (globeP->selectedRow == -1)
							{
								if (getNextSelectableRow(globeP))
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
								}
								else
								{
									globeP->focusedObjectId = btnPhoneDial;
								}
							}
							else
							{
								globeP->focusedObjectId = tblPhoneList;
								enqueueTableSelectEvent(globeP);
							}
						}
						else
						{
							globeP->focusedObjectId = btnPhoneDial;
						}
						shouldChangeFocus = true;
						break;
						
					case tblPhoneList:
						if (! getNextSelectableRow(globeP))
						{
							TblUnhighlightSelection(globeP->tblPhoneListP);
							globeP->focusedObjectId = btnPhoneDial;
							shouldChangeFocus = true;
						}
						else
						{
							TblUnhighlightSelection(globeP->tblPhoneListP);
							TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
							enqueueTableSelectEvent(globeP);
						}
						break;
					case btnPhoneDial:
					case btnPhoneContact:
					case btnPhoneText:
					case btnPhoneClear:
					case btnPhoneCancel:
						if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
						{
							if (globeP->selectedRow == -1)
							{
								if (getNextSelectableRow(globeP))
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
									shouldChangeFocus = true;
								}
							}
							else
							{
								globeP->focusedObjectId = tblPhoneList;
								enqueueTableSelectEvent(globeP);
								shouldChangeFocus = true;
							}
						}
						break;
				}
				isKeyHandled = true;
				break;
			case chrLeftArrow:		//
			case vchrRockerLeft:
				isKeyHandled = true;
				switch (globeP->focusedObjectId)
				{
					case btnPhoneCancel:
						globeP->focusedObjectId = btnPhoneClear;
						shouldChangeFocus = true;
						break;
					case btnPhoneClear:
						globeP->focusedObjectId = btnPhoneText;
						shouldChangeFocus = true;
						break;
					case btnPhoneText:
						globeP->focusedObjectId = btnPhoneContact;
						shouldChangeFocus = true;
						break;
					case btnPhoneContact:
						globeP->focusedObjectId = btnPhoneDial;
						shouldChangeFocus = true;
						break;
					case btnPhoneDial:
						if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
						{
							if (globeP->selectedRow == -1)
							{
								if (getNextSelectableRow(globeP))
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
								}
								else
								{
									if (globeP->contentType != CONTENT_TYPE_DIAL_PAD)
									{
										//globeP->focusedObjectId = ptriPhoneCategoryList;
									}
									else
									{
										globeP->focusedObjectId = gdtPhoneNumber;
									}
								}
							}
							else
							{
								TblUnhighlightSelection(globeP->tblPhoneListP);
								TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
								globeP->focusedObjectId = tblPhoneList;
								enqueueTableSelectEvent(globeP);
							}
						}
						else
						{
							if (globeP->contentType != CONTENT_TYPE_DIAL_PAD)
							{
								//globeP->focusedObjectId = ptriPhoneCategoryList;
							}
							else
							{
								globeP->focusedObjectId = gdtPhoneNumber;
							}
						}
						shouldChangeFocus = true;
						break;
					case tblPhoneList:
						TblUnhighlightSelection(globeP->tblPhoneListP);
						globeP->focusedObjectId = gdtPhoneNumber;
						shouldChangeFocus = true;
						break;
					case gdtPhoneNumber:
						globeP->focusedObjectId = gdtContentType;
						globeP->shouldEraseInsPt = true;
						shouldChangeFocus = true;
						break;
				}
				break;
			case chrRightArrow:		//
			case vchrRockerRight:
				isKeyHandled = true;
				switch (globeP->focusedObjectId)
				{
					case gdtContentType:
						globeP->focusedObjectId = gdtPhoneNumber;
						shouldChangeFocus = true;
						break;
					case gdtPhoneNumber:					
						if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
						{
							if (globeP->selectedRow == -1)
							{
								if (getNextSelectableRow(globeP))
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
								}
								else
								{
									globeP->focusedObjectId = btnPhoneDial;
								}
							}
							else
							{
								TblUnhighlightSelection(globeP->tblPhoneListP);
								TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
								globeP->focusedObjectId = tblPhoneList;
								enqueueTableSelectEvent(globeP);
							}
						}
						else
						{
							globeP->focusedObjectId = btnPhoneDial;
						}
						shouldChangeFocus = true;
						break;
						
					case tblPhoneList:
						TblUnhighlightSelection(globeP->tblPhoneListP);
						globeP->focusedObjectId = btnPhoneDial;
						shouldChangeFocus = true;
						break;
					case btnPhoneDial:
						globeP->focusedObjectId = btnPhoneContact;
						shouldChangeFocus = true;
						break;
					case btnPhoneContact:
						globeP->focusedObjectId = btnPhoneText;
						shouldChangeFocus = true;
						break;
					case btnPhoneText:
						globeP->focusedObjectId = btnPhoneClear;
						shouldChangeFocus = true;
						break;
					case btnPhoneClear:
						globeP->focusedObjectId = btnPhoneCancel;
						shouldChangeFocus = true;
						break;
				}
				break;
			case vchrRockerCenter:
				if (! (eventP->data.keyDown.modifiers & willSendUpKeyMask))
				{
					switch (globeP->focusedObjectId)
					{
						case gdtPhoneNumber:
							globeP->shouldEraseInsPt = true;
						case tblPhoneList:
							globeP->focusedObjectId = btnPhoneDial;
							shouldChangeFocus = true;
							isKeyHandled = true;
							break;
						case gdtContentType:
							HsNavRemoveFocusRing(globeP->frmPhoneUIP);
							enqueueGadgetSelectEvent(globeP->focusedObjectId);
							isKeyHandled = true;
							break;
					}
				}
				break;
			case TREO_680_GREEN_KEY:
			case keyHard1:
				if (StrLen(globeP->phoneNumberP) > 0)
				{
					dialCall(globeP->phoneNumberP, 0, globeP);
					(*actionTypeP) = PHONE_ACTION_EXIT;
				}
				isKeyHandled = true;
				break;
			case keyHard2:
				if (StrLen(globeP->phoneNumberP) > 0)
				{	
					UInt16					recordId;
					if (searchContactByPhoneNumber(&recordId, globeP->cacheP, globeP->phoneNumberP, StrLen(globeP->phoneNumberP), globeP))	//
						openPhoneContact(globeP->phoneNumberP, 0, globeP);
					else
						savePhoneNumber(globeP->phoneNumberP, 0, globeP);
					
					(*actionTypeP) = PHONE_ACTION_EXIT;
				}
				isKeyHandled = true;
				break;
			case keyHard3:
				sendPhoneText(globeP->phoneNumberP, 0, globeP);
				(*actionTypeP) = PHONE_ACTION_EXIT;
				isKeyHandled = true;
				break;
			case keyLaunch:
				(*actionTypeP) = PHONE_ACTION_EXIT;
				isKeyHandled = true;
				break;
			case keyLeftShift:
			case keyRightShift:
			case keyLeftAlt:
				isKeyHandled = true;
				break;
			default:
				if ((eventP->data.keyDown.keyCode >= keyA && eventP->data.keyDown.keyCode <= keyZ) || chr == keyZero ||
					chr == keyBackspace || chr == '*' || chr == '#' || chr == '+')
				{
					UInt16			i	= StrLen(globeP->phoneNumberP);
					
					if (((eventP->data.keyDown.chr >= keyZero && eventP->data.keyDown.chr <= keyNine) ||
						((Char)eventP->data.keyDown.chr == '*' || (Char)eventP->data.keyDown.chr == '#' || (Char)eventP->data.keyDown.chr == '+')) &&
						i < 63)
					{
						globeP->phoneNumberP[i] = (Char)eventP->data.keyDown.chr;
						i ++;
						isKeyHandled = true;
					}
					else if (chr == keyBackspace && i > 0)
					{
						i --;
						globeP->phoneNumberP[i] = (Char)chrNull;
						isKeyHandled = true;
					}
					
					if (globeP->contentType != CONTENT_TYPE_DIAL_PAD)
					{
						if (chr == keyBackspace)
						{
							if (globeP->contactSearchKeywordLength > 0)
							{
								globeP->contactSearchKeywordLength --;
								globeP->contactSearchKeywordP[globeP->contactSearchKeywordLength] = (Char)chrNull;
								isKeyHandled = true;
							}
						}
						else if (globeP->contactSearchKeywordLength < 10)
						{
							globeP->contactSearchKeywordP[globeP->contactSearchKeywordLength] = (Char)(eventP->data.keyDown.keyCode - 32);
							globeP->contactSearchKeywordLength ++;
							isKeyHandled = true;
						}
						
						if (isKeyHandled)	//
						{
							globeP->setTableContent = SET_TABLE_CONTENT_CONTACTS;
							//FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
						}
					}
					if (isKeyHandled)
					{
						FrmUpdateForm(frmPhoneUI, FORM_UPDATE_CONTENT);
					}
				}
				break;
		}
		
		if (shouldChangeFocus)
		{
			HsNavObjectTakeFocus(globeP->frmPhoneUIP, globeP->focusedObjectId);
		}
	}
	
	return isKeyHandled;
}

//¼
static Boolean phoneAppEventHandler(EventType *eventP, UInt8 *actionTypeP, GlobeType *globeP, LauncherSettingType *launcherSettingP)
{
	UInt16			i;
	Boolean			isEventHandled	= false;
	
	switch (eventP->eType)
	{
		case frmLoadEvent:
			if (eventP->data.frmLoad.formID == frmPhoneUI)
			{
				//ʼ
				globeP->frmPhoneUIP = FrmInitForm(frmPhoneUI);
				
				//ȡؼָ
				globeP->lstContentTypeP = (ListType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, lstContentType);
				//globeP->ptriPhoneCategoryListP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, ptriPhoneCategoryList);
				//globeP->lstPhoneCategoryListP = (ListType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, lstPhoneCategoryList);
				globeP->tblPhoneListIndex = FrmGetObjectIndex(globeP->frmPhoneUIP, tblPhoneList);
				globeP->tblPhoneListP = (TableType *)FrmGetObjectPtr(globeP->frmPhoneUIP, globeP->tblPhoneListIndex);
				globeP->sclPhoneListIndex = FrmGetObjectIndex(globeP->frmPhoneUIP, sclPhoneList);
				globeP->sclPhoneListP = (ScrollBarType *)FrmGetObjectPtr(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
				for (i = btnPhoneButton1; i <= btnPhoneButtonS; i ++)
				{
					globeP->btnPhoneButtonsP[i - btnPhoneButton1] = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, i);
				}
				globeP->lstPhoneDialP = (ListType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, lstPhoneDial);
				globeP->btnPhoneDialP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, btnPhoneDial);
				globeP->lstPhoneContactP = (ListType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, lstPhoneContact);
				globeP->btnPhoneContactP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, btnPhoneContact);
				globeP->btnPhoneTextP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, btnPhoneText);
				globeP->btnPhoneClearP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, btnPhoneClear);
				globeP->btnPhoneCancelP = (ControlType *)GET_OBJECT_POINTER(globeP->frmPhoneUIP, btnPhoneCancel);
				
				//ʼб
				LstSetListChoices(globeP->lstPhoneDialP, globeP->callCardsPP, globeP->callCardCount);
				LstSetHeight(globeP->lstPhoneDialP, globeP->callCardCount);
				LstSetPosition(globeP->lstPhoneDialP, 3, 156 - (globeP->callCardCount * 11));
				
				//ʼ
				TblSetColumnUsable(globeP->tblPhoneListP, 0, true);
				for (i = 0; i < TABLE_ROWS_NUMS; i ++)
				{
					TblSetRowUsable(globeP->tblPhoneListP, i, true);
					TblSetItemStyle(globeP->tblPhoneListP, i, 0, customTableItem);
				}
				TblSetItemPtr(globeP->tblPhoneListP, 0, 0, (void *)globeP);
				
				//ʼؼ
				//PmSysGadgetStatusGadgetTypeSet(globeP->pmGadgetLibRef, (void *)globeP->frmPhoneUIP, gdtBlueTooth, pmSysGadgetStatusGadgetBt);
				//PmSysGadgetStatusGadgetTypeSet(globeP->pmGadgetLibRef, (void *)globeP->frmPhoneUIP, gdtSignal, pmSysGadgetStatusGadgetSignal);
				//PmSysGadgetStatusGadgetTypeSet(globeP->pmGadgetLibRef, (void *)globeP->frmPhoneUIP, gdtBattery, pmSysGadgetStatusGadgetBattery);
				
				getOperatorName(globeP, launcherSettingP);
				FrmSetActiveForm(globeP->frmPhoneUIP);
				
				isEventHandled = true;
			}
			break;
		case frmOpenEvent:
			if (eventP->data.frmOpen.formID == frmPhoneUI)
			{
				//ʾ
				FrmDrawForm(globeP->frmPhoneUIP);
				
				//ûͼģʽ
				WinSetDrawMode(winOverlay);
				
				//ĬϴͨѶ¼
				LstSetSelection(globeP->lstContentTypeP, globeP->defaultView);
				switch(globeP->defaultView)
				{
					case CONTENT_TYPE_CALL_LOG:
						globeP->callLogCategory = CALL_LOG_CATEGORY_ALL;
						globeP->setTableContent = SET_TABLE_CONTENT_CALL_LOG;
						break;
					case CONTENT_TYPE_CONTACTS:
						globeP->contactsCategory = dmAllCategories;
						globeP->setTableContent = SET_TABLE_CONTENT_CONTACTS;
						break;
					case CONTENT_TYPE_DIAL_PAD:
						globeP->setTableContent = SET_TABLE_CONTENT_DIAL_PAD;
						break;
				}
				
				FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
				
				FrmSetNavState(globeP->frmPhoneUIP, kFrmNavStateFlagsObjectFocusMode);
				HsNavObjectTakeFocus(globeP->frmPhoneUIP, gdtPhoneNumber);
				globeP->focusedObjectId = gdtPhoneNumber;
				
				isEventHandled = true;
			}
			break;
		case frmUpdateEvent:
			if (eventP->data.frmUpdate.formID == frmPhoneUI)
			{
				drawPhonePad(globeP, eventP->data.frmUpdate.updateCode);
				
				isEventHandled = true;
			}
			break;
		case frmObjectFocusTakeEvent:
			if (eventP->data.frmObjectFocusTake.formID == frmPhoneUI)
			{
				HsNavRemoveFocusRing(globeP->frmPhoneUIP);
				if (globeP->shouldEraseInsPt)
				{
					globeP->isInsPtDrawed = false;
					globeP->shouldEraseInsPt = false;
					FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
				}
				if (FrmDispatchEvent(eventP))
				{
					switch (eventP->data.frmObjectFocusTake.objectID)
					{
						case tblPhoneList:
							/*TblUnhighlightSelection(globeP->tblPhoneListP);
							TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);*/
							if ((globeP->contentType == CONTENT_TYPE_CALL_LOG && globeP->callLogCount > 0) ||
							(globeP->contentType == CONTENT_TYPE_CONTACTS && globeP->fieldMappingCount > 0))
							{
								if (globeP->selectedRow == -1)
								{
									if (getNextSelectableRow(globeP))
									{
										globeP->focusedObjectId = tblPhoneList;
										enqueueTableSelectEvent(globeP);
									}
									else
									{
										globeP->focusedObjectId = gdtPhoneNumber;										
									}
								}
								else
								{
									globeP->focusedObjectId = tblPhoneList;
									enqueueTableSelectEvent(globeP);
								}
							}
							else
							{
								globeP->focusedObjectId = gdtPhoneNumber;
								
							}
							break;
						case gdtContentType:
							HsNavDrawFocusRing(globeP->frmPhoneUIP, globeP->focusedObjectId, hsNavFocusRingNoExtraInfo, &globeP->tabRectangle, hsNavFocusRingStyleSquare, true);
							break;
					}
					
					isEventHandled = true;
				}
				HsGrfSetStateExt(false, false, true, false, false, false);
			}
			break;
		case winEnterEvent:
			if (eventP->data.winEnter.enterWindow == (WinHandle)globeP->frmPhoneUIP)
			{
				globeP->isMenuActived = false;
			}
			break;
		case menuEvent:
			switch (eventP->data.menu.itemID)
			{
				case menuitemCopy:
					ClipboardAddItem(clipboardText, globeP->phoneNumberP, StrLen(globeP->phoneNumberP) + 1);
					break;
				case menuitemCut:
					ClipboardAddItem(clipboardText, globeP->phoneNumberP, StrLen(globeP->phoneNumberP) + 1);
					MemSet(globeP->phoneNumberP, 64, 0);
					FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
					break;
				case menuitemPaste:
				{
					MemHandle		clipH	= ClipboardGetItem(clipboardText, &i);
					
					if (i > 0)
					{
						if (i > 63)
						{
							i = 63;
						}
						StrNCopy(globeP->cacheP, (Char *)MemHandleLock(clipH), i);
						MemHandleUnlock(clipH);
						StrDigitCopy(globeP->phoneNumberP, globeP->cacheP);
						MemSet(globeP->cacheP, 128, 0);
						FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
					}
					break;
				}
				//case menuitemSelectAll:
					//FldSetSelection(globeP->fldPhoneNumberP, 0, FldGetTextLength(globeP->fldPhoneNumberP));
					//break;
				case menuitemPurgeCallLog:
					purgeCallLog(globeP);
					break;
				case menuitemSetup:
					LstSetListChoices(globeP->lstPhoneDialP, NULL, 0);
					freeCallCard(globeP);
					settingEventHandler();
					getPreferences(globeP);
					LstSetListChoices(globeP->lstPhoneDialP, globeP->callCardsPP, globeP->callCardCount);
					LstSetHeight(globeP->lstPhoneDialP, globeP->callCardCount);
					LstSetPosition(globeP->lstPhoneDialP, 1, 157 - (globeP->callCardCount * 11));
					break;
				case menuitemAbout:
				{
					FormType		*frmAboutP	= FrmInitForm(frmAbout);
					
					FrmDoDialog(frmAboutP);
					
					FrmDeleteForm(frmAboutP);
					
					FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
					break;
				}
			}
			globeP->isMenuActived = false;
			FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
			isEventHandled = true;
			break;
		case sclRepeatEvent:
			globeP->selectedRow = -1;
			TblDrawTable(globeP->tblPhoneListP);
			break;
		case tblSelectEvent:
			if (isRowCanntBeSelected(globeP, eventP->data.tblEnter.row))
			{
				if (globeP->focusedObjectId == tblPhoneList && globeP->selectedRow != -1)
				{
					TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
					FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
				}
				else
				{
					TblUnhighlightSelection(globeP->tblPhoneListP);
					HsNavObjectTakeFocus(globeP->frmPhoneUIP, globeP->focusedObjectId);
				}
			}
			else
			{
				if (globeP->focusedObjectId != tblPhoneList)
				{
					HsNavObjectTakeFocus(globeP->frmPhoneUIP, tblPhoneList);
					if (globeP->focusedObjectId == gdtPhoneNumber)
					{
						globeP->shouldEraseInsPt = true;
					}
					globeP->focusedObjectId = tblPhoneList;
				}
				globeP->selectedRow = eventP->data.tblSelect.row;
				TblSelectItem(globeP->tblPhoneListP, globeP->selectedRow, 0);
				MemSet(globeP->phoneNumberP, 64, 0);
				insertPhoneNumberFromTable(globeP, eventP->data.tblSelect.row);
				
				FrmUpdateForm(frmPhoneUI, FORM_UPDATE_PHONE_NUMBER);
			}
			
			isEventHandled = true;
			break;
		case popSelectEvent:
			if (eventP->data.popSelect.selection != noListSelection)
			{
				switch (globeP->contentType)
				{
					case CONTENT_TYPE_CALL_LOG:
						//÷
						if (eventP->data.popSelect.selection == 0)
						{
							globeP->callLogCategory = CALL_LOG_CATEGORY_ALL;
						}
						else
						{
							globeP->callLogCategory = eventP->data.popSelect.selection;
						}
						
						globeP->setTableContent = SET_TABLE_CONTENT_CALL_LOG;
						
						FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
						break;
					case CONTENT_TYPE_CONTACTS:
						//÷
						if (eventP->data.popSelect.selection == 0)
						{
							globeP->contactsCategory = dmAllCategories;
						}
						else
						{
							globeP->contactsCategory = globeP->contactCategoryMappingP[eventP->data.popSelect.selection];
						}
						
						globeP->setTableContent = SET_TABLE_CONTENT_CONTACTS;
						
						FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
						break;
				}
				globeP->selectedRow = -1;
				isEventHandled = true;
			}
			//globeP->focusedObjectId = ptriPhoneCategoryList;
			break;
		case ctlSelectEvent:
			switch (eventP->data.ctlSelect.controlID)
			{
				case btnPhoneDial:
					if (StrLen(globeP->phoneNumberP) > 0)
					{
						if (dialCall(globeP->phoneNumberP, LstPopupList(globeP->lstPhoneDialP), globeP))
						{
							(*actionTypeP) = PHONE_ACTION_EXIT;
						}
					}
					globeP->focusedObjectId = btnPhoneDial;
					isEventHandled = true;
					break;
				case btnPhoneContact:
					if (StrLen(globeP->phoneNumberP) > 0)
					{
						UInt16 item = LstPopupList(globeP->lstPhoneContactP);
						
						if (item == 0)
							savePhoneNumber(globeP->phoneNumberP, 0, globeP);
						else
							openPhoneContact(globeP->phoneNumberP, 0, globeP);
							
						(*actionTypeP) = PHONE_ACTION_EXIT;
					}
					globeP->focusedObjectId = btnPhoneContact;
					isEventHandled = true;
					break;
				case btnPhoneText:
					sendPhoneText(globeP->phoneNumberP, 0, globeP);
					(*actionTypeP) = PHONE_ACTION_EXIT;
					isEventHandled = true;
					break;
				case btnPhoneClear:
                    MemSet(globeP->phoneNumberP, 64, 0);
                    MemSet(globeP->contactSearchKeywordP,11,0);
                    globeP->contactSearchKeywordLength=0;
					FrmUpdateForm(frmPhoneUI, FORM_UPDATE_CONTENT);
					globeP->focusedObjectId = btnPhoneClear;
					isEventHandled = true;
					break;
				case btnPhoneCancel:
					(*actionTypeP) = PHONE_ACTION_EXIT;
					globeP->focusedObjectId = btnPhoneCancel;
					isEventHandled = true;
					break;
				default:
					if (eventP->data.ctlSelect.controlID >= btnPhoneButton1 && eventP->data.ctlSelect.controlID <= btnPhoneButtonS)
					{
						switch (eventP->data.ctlSelect.controlID)
						{
							case btnPhoneButton1:
								EvtEnqueueKey(keyOne, keyE, 0x0800);
								break;
							case btnPhoneButton2:
								EvtEnqueueKey(keyTwo, keyR, 0x0800);
								break;
							case btnPhoneButton3:
								EvtEnqueueKey(keyThree, keyT, 0x0800);
								break;
							case btnPhoneButton4:
								EvtEnqueueKey(keyFour, keyD, 0x0800);
								break;
							case btnPhoneButton5:
								EvtEnqueueKey(keyFive, keyF, 0x0800);
								break;
							case btnPhoneButton6:
								EvtEnqueueKey(keySix, keyG, 0x0800);
								break;
							case btnPhoneButton7:
								EvtEnqueueKey(keySeven, keyX, 0x0800);
								break;
							case btnPhoneButton8:
								EvtEnqueueKey(keyEight, keyC, 0x0800);
								break;
							case btnPhoneButton9:
								EvtEnqueueKey(keyNine, keyV, 0x0800);
								break;
							case btnPhoneButtonP:
								EvtEnqueueKey(0x002A, keyZ, 0x0800);
								break;
							case btnPhoneButton0:
								EvtEnqueueKey(keyZero, 0xE020, 0x0800);
								break;
							case btnPhoneButtonS:
								EvtEnqueueKey(0x0023, keyB, 0x0800);
								break;
						}
						isEventHandled = true;
					}
					break;
			}
			break;
		case penDownEvent:
			if ((eventP->screenX >= 80 ) && (eventP->screenY >= 0 && eventP->screenY <= 12))
			{
				EvtEnqueueKey(vchrMenu, 0, 8);
				isEventHandled = true;
			}
			else
			{
				if (RctPtInRectangle(eventP->screenX, eventP->screenY, &globeP->tabRectangle))	//лView
				{
					switch (LstPopupList(globeP->lstContentTypeP))
					{
						case 0:		//ͨѶ¼
							globeP->callLogCategory = CALL_LOG_CATEGORY_ALL;
							globeP->setTableContent = SET_TABLE_CONTENT_CALL_LOG;
							break;
						case 1:		//ϵ
							globeP->setTableContent = SET_TABLE_CONTENT_CONTACTS;
							break;
						case 2:		//
							globeP->setTableContent = SET_TABLE_CONTENT_DIAL_PAD;
							break;
					}
					FrmUpdateForm(frmPhoneUI, frmRedrawUpdateCode);
				}
				else if (RctPtInRectangle(eventP->screenX, eventP->screenY, &globeP->phoneNumberRectangle[0]))	//л
				{
					HsNavObjectTakeFocus(globeP->frmPhoneUIP, gdtPhoneNumber);
					globeP->focusedObjectId = gdtPhoneNumber;
				}
			}
			break;
	}
	
	return isEventHandled;
}

//ʾؿؼ
static void showHideControls(UInt8 type, GlobeType *globeP)
{
	UInt16		i;
	
	if (type == SET_TABLE_CONTENT_DIAL_PAD)
	{
		//CtlHideControl(globeP->ptriPhoneCategoryListP);
		FrmHideObject(globeP->frmPhoneUIP, globeP->tblPhoneListIndex);
		FrmHideObject(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
		
		for (i = 0; i < 12; i ++)
		{
			CtlShowControl(globeP->btnPhoneButtonsP[i]);
		}
	}
	else
	{
		for (i = 0; i < 12; i ++)
		{
			CtlHideControl(globeP->btnPhoneButtonsP[i]);
		}
		
		//CtlShowControl(globeP->ptriPhoneCategoryListP);
		FrmShowObject(globeP->frmPhoneUIP, globeP->tblPhoneListIndex);
	}
}

//¼
static void phoneMainEventHandler(PluginParameterType *paramP)
{
	EventType				event;
	UInt16					error;
	LauncherSettingType		*launcherSettingP	= (LauncherSettingType *)MemPtrNew(sizeof(LauncherSettingType));
	GlobeType				*globeP				= (GlobeType *)MemPtrNew(sizeof(GlobeType));
	UInt8					actionType			= PHONE_ACTION_NO_EXIT;
	UInt8					evtWaitTime			= SysTicksPerSecond() / 2;
	
	//ȡ
	error = sizeof(LauncherSettingType);
	
	if (PrefGetAppPreferences(APPLICATION_CREATOR, LAUNCHER_PREFERENCE_ID, launcherSettingP, &error, true) != noPreferenceFound)
	{
		//ʼ
		MemSet(globeP, sizeof(GlobeType), 0);
		getPreferences(globeP);
		getPYTable(globeP);
		globeP->defaultDisplayEffect = paramP->defaultDisplayEffect;
		globeP->defaultMaskPattern = paramP->defaultMaskPattern;
		globeP->textColor = paramP->textColor;
		globeP->textOutlineColor = paramP->textOutlineColor;
		globeP->foreColor = paramP->foreColor;
		globeP->backgdColor = paramP->backgdColor;
		setRectangle(globeP);
		globeP->dateStringP = (Char *)MemPtrNew(32);
		MemSet(globeP->dateStringP, 32, 0);
		globeP->timeStringP = (Char *)MemPtrNew(32);
		MemSet(globeP->timeStringP, 32, 0);
		getBmpResource(globeP);
		globeP->bmpBackgroundP = getBackgdBitmap(launcherSettingP);
		globeP->offscreenWindowH = WinCreateOffscreenWindow(160, 160, nativeFormat, &error);
		
		if (error == errNone)
		{
			globeP->callLogCategoryPP = (Char **)MemPtrNew(16);
			globeP->callLogCategoryPP[0] = (Char *)MemPtrNew(StrLen(STRING_CALL_LOG_CATEGORY_ALL) + 1);
			StrCopy(globeP->callLogCategoryPP[0], STRING_CALL_LOG_CATEGORY_ALL);
			globeP->callLogCategoryPP[1] = (Char *)MemPtrNew(StrLen(STRING_CALL_LOG_CATEGORY_INCOMING) + 1);
			StrCopy(globeP->callLogCategoryPP[1], STRING_CALL_LOG_CATEGORY_INCOMING);
			globeP->callLogCategoryPP[2] = (Char *)MemPtrNew(StrLen(STRING_CALL_LOG_CATEGORY_MISSED) + 1);
			StrCopy(globeP->callLogCategoryPP[2], STRING_CALL_LOG_CATEGORY_MISSED);
			globeP->callLogCategoryPP[3] = (Char *)MemPtrNew(StrLen(STRING_CALL_LOG_CATEGORY_OUTGOING) + 1);
			StrCopy(globeP->callLogCategoryPP[3], STRING_CALL_LOG_CATEGORY_OUTGOING);
			if (getContactUnitMemoryAndCategory(globeP))
			{
				if (globeP->fieldMappingP)
				{
					globeP->contactsCategory = dmAllCategories;
					globeP->contactUnitP = (AddrDBRecordType *)MemPtrNew(sizeof(AddrDBRecordType));
					
					//Gadget
					SysLibLoad(kPmSysGadgetLibType, kPmSysGadgetLibCreator, &globeP->pmGadgetLibRef);
					PmSysGadgetLibOpen(globeP->pmGadgetLibRef);
					
					//򿪵绰
					HsGetPhoneLibrary(&globeP->hsPhoneLibRef);
					PhnLibOpen(globeP->hsPhoneLibRef);
					
					globeP->insPtX = 3;
					globeP->insPtY = globeP->phoneNumberRectangle[0].topLeft.y;
					
					FrmPopupForm(frmPhoneUI);
					
					do
					{
						EvtGetEvent(&event, evtWaitTime);
						
						switch (globeP->setTableContent)
						{
							case SET_TABLE_CONTENT_CALL_LOG:
								showHideControls(globeP->setTableContent, globeP);
								
								//ȡǰͨѶ¼
								getCallLog(globeP);
								
								//ñƺ
								TblSetCustomDrawProcedure(globeP->tblPhoneListP, 0, tableDrawCallLogItem);
								
								//ù
								if (globeP->callLogCount > TABLE_ROWS_NUMS)
								{
									FrmShowObject(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
									SclSetScrollBar(globeP->sclPhoneListP, 0, 0, globeP->callLogCount - TABLE_ROWS_NUMS, TABLE_ROWS_NUMS);
								}
								else
								{
									SclSetScrollBar(globeP->sclPhoneListP, 0, 0, 0, TABLE_ROWS_NUMS);
									FrmHideObject(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
								}
								
								//÷
								globeP->contentType = CONTENT_TYPE_CALL_LOG;
								//setCategoryText(globeP);
								
								globeP->selectedRow = -1;
								globeP->setTableContent = SET_TABLE_CONTENT_NA;
								break;
							case SET_TABLE_CONTENT_CONTACTS:
								showHideControls(globeP->setTableContent, globeP);
								
								//ȡǰͨѶ¼
								searchMatchedContactList(globeP);
								
								//ñƺ
								TblSetCustomDrawProcedure(globeP->tblPhoneListP, 0, tableDrawContactsItem);
								
								//ù
								if (globeP->fieldMappingCount > TABLE_ROWS_NUMS)
								{
									FrmShowObject(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
									SclSetScrollBar(globeP->sclPhoneListP, 0, 0, globeP->fieldMappingCount - TABLE_ROWS_NUMS, TABLE_ROWS_NUMS);
								}
								else
								{
									SclSetScrollBar(globeP->sclPhoneListP, 0, 0, 0, TABLE_ROWS_NUMS);
									FrmHideObject(globeP->frmPhoneUIP, globeP->sclPhoneListIndex);
								}
								
								//÷
								globeP->contentType = CONTENT_TYPE_CONTACTS;
								//setCategoryText(globeP);
								
								globeP->selectedRow = -1;
								globeP->setTableContent = SET_TABLE_CONTENT_NA;
								break;
							case SET_TABLE_CONTENT_DIAL_PAD:
								showHideControls(globeP->setTableContent, globeP);
								
								globeP->contentType = CONTENT_TYPE_DIAL_PAD;
								
								globeP->selectedRow = -1;
								globeP->setTableContent = SET_TABLE_CONTENT_NA;
								break;
						}
						
						if ((! globeP->isMenuActived) && globeP->focusedObjectId == gdtPhoneNumber)
						{
							WinSetDrawMode(winInvert);
							WinSetForeColorRGB(&globeP->textColor, NULL);
							WinPaintLine(globeP->insPtX, globeP->insPtY, globeP->insPtX, globeP->insPtY + 21);
							WinPaintLine(globeP->insPtX + 1, globeP->insPtY, globeP->insPtX + 1, globeP->insPtY + 21);
							WinSetDrawMode(winOverlay);
							globeP->isInsPtDrawed = (! globeP->isInsPtDrawed);
						}
						
						if (! frmPhoneUICustomEventHandler(&event, globeP, launcherSettingP))
						{
							if (! phoneKeyEventHandler(&event, &actionType, globeP))
							{
								if (! SysHandleEvent(&event))
								{
									if (! MenuHandleEvent(0, &event, &error))
									{
										if (! phoneAppEventHandler(&event, &actionType, globeP, launcherSettingP))
										{
											FrmDispatchEvent(&event);
										}
									}
									else
									{
										globeP->isMenuActived = true;
									}
								}
							}
						}
					} while(event.eType != appStopEvent && actionType == PHONE_ACTION_NO_EXIT);
					
					HsGrfSetStateExt(false, false, false, false, false, false);
					
					FrmReturnToForm(0);
					
					//б
					freeCallLog(globeP);
					
					//رտ
					PhnLibClose(globeP->hsPhoneLibRef);
					PmSysGadgetLibClose(globeP->pmGadgetLibRef);
					
					//ͷڴ
					MemPtrFree(globeP->contactUnitP);
					MemPtrFree(globeP->fieldMappingP);
				}
				//ͷڴ
				freeContactCategory(globeP);
			}
			
			//ͷڴ
			MemPtrFree(globeP->callLogCategoryPP[3]);
			MemPtrFree(globeP->callLogCategoryPP[2]);
			MemPtrFree(globeP->callLogCategoryPP[1]);
			MemPtrFree(globeP->callLogCategoryPP[0]);
			MemPtrFree(globeP->callLogCategoryPP);
			WinDeleteWindow(globeP->offscreenWindowH, false);
		}
		if (globeP->bmpBackgroundP)
		{
			BmpDelete((BitmapType *)globeP->bmpBackgroundP);
		}
		freeBmpResource(globeP);
		MemPtrFree(globeP->timeStringP);
		MemPtrFree(globeP->dateStringP);
		freeCallCard(globeP);
	}
	MemPtrFree(globeP);
	MemPtrFree(launcherSettingP);
}

#if 0
#pragma mark -
#pragma mark SETTING FUNCTIONS
#pragma mark -
#endif

static void settingEventHandler()
{
	EventType				event;
	FormType				*frmSetupP;
	ControlType				*cbRelayKeyP;
	ControlType				*pbtnViewsP[3];
	FieldType				*fldCallCard[5];
	UInt16					i;
	NotifyParameterType		*notifyParameterP;
	NotifyParameterType		tmpNotifyParameter;
	Boolean					isEventHandled;
	Boolean					shouldExit		= false;
	SettingType				*settingP		= (SettingType *)MemPtrNew(sizeof(SettingType));
	UInt16					settingSize		= sizeof(SettingType);
	
	FrmPopupForm(frmSetup);
	
	do
	{
		EvtGetEvent(&event, evtWaitForever);
		
		if (! SysHandleEvent(&event))
		{
			isEventHandled = false;
			
			switch (event.eType)
			{
				case frmLoadEvent:
					if (event.data.frmLoad.formID == frmSetup)
					{
						frmSetupP = FrmInitForm(frmSetup);
						cbRelayKeyP = (ControlType *)GET_OBJECT_POINTER(frmSetupP, cbRelayKey);
						for (i = 0; i < 3; i ++)
						{
							pbtnViewsP[i] = (ControlType *)GET_OBJECT_POINTER(frmSetupP, pbtnCallLog + i);
						}
						for (i = 0; i < 5; i ++)
						{
							fldCallCard[i] = (FieldType *)GET_OBJECT_POINTER(frmSetupP, fldCallCard1 + i);
						}
						FrmSetActiveForm(frmSetupP);
						isEventHandled = true;
					}
					break;
				case frmOpenEvent:
					if (event.data.frmOpen.formID == frmSetup)
					{
						if (PrefGetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, settingP, &settingSize, true) == noPreferenceFound)
						{
							MemSet(settingP, settingSize, 0);
							
							StrCopy(settingP->callCardPP[0], STRING_DEFAULT_CALL_CARD);
							
							//
							PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, settingSize, true);
						}
						
						FrmDrawForm(frmSetupP);
						
						CtlSetValue(cbRelayKeyP, settingP->shouldRelayKey);
						CtlSetValue(pbtnViewsP[settingP->defaultView], 1);
						for (i = 0; i < 5; i ++)
						{
							if ((UInt8)settingP->callCardPP[i][0] != 0)
							{
								FldInsert(fldCallCard[i], settingP->callCardPP[i], StrLen(settingP->callCardPP[i]));
							}
						}
						isEventHandled = true;
					}
					break;
				case ctlSelectEvent:
					switch (event.data.ctlSelect.controlID)
					{
						case btnSetupOK:
							shouldExit = true;
							break;
						case pbtnCallLog:
							settingP->defaultView = 0;
							break;
						case pbtnContacts:
							settingP->defaultView = 1;
							break;
						case pbtnDialPad:
							settingP->defaultView = 2;
							break;
					}
					isEventHandled = true;
					break;
			}
			
			if (! isEventHandled)
			{
				FrmDispatchEvent(&event);
			}
		}
	}while(event.eType != appStopEvent && shouldExit != true);
	
	settingP->shouldRelayKey = CtlGetValue(cbRelayKeyP);
	
	for (i = 0; i < 5; i ++)
	{
		//UInt16  n = FldGetTextLength(fldCallCard[i]);
		//
		if (FldGetTextLength(fldCallCard[i]) > 0)
		{
			StrCopy(settingP->callCardPP[i], FldGetTextPtr(fldCallCard[i]));
		}
		else
		{
			MemSet(settingP->callCardPP[i], 11, 0);
		}
	}
	
	PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, settingSize, true);
	
	if (FtrGet(APPLICATION_CREATOR, NOTIFY_PARAMETER_FEATURE_ID, (UInt32 *)&notifyParameterP) == errNone)
	{
		tmpNotifyParameter = (*notifyParameterP);
		tmpNotifyParameter.shouldRelayKey = settingP->shouldRelayKey;
		
		DmWrite(notifyParameterP, 0, &tmpNotifyParameter, sizeof(NotifyParameterType));
	}
	
	MemPtrFree(settingP);
	
	FrmReturnToForm(0);
}

#if 0
#pragma mark -
#pragma mark COMMON FUNCTIONS
#pragma mark -
#endif

//KMPַ㷨
static Boolean arraySearchKMP(Int16 *nextVP, UInt32 *wordP, UInt16 wordLength, UInt32 *packageP, UInt16 packageLength)
{
	Int16	i = 0;
	Int16	j = -1;
	
	//Construct the nextV table
	nextVP[0] = -1;
	while (i < wordLength - 1)
	{
		while (j == -1 || (i < wordLength && (wordP[i] & wordP[j])))
		{
			i ++;
			j ++;
			if (wordP[i] != wordP[j])
			{
				nextVP[i] = j;
			}
			else
			{
				nextVP[i] = nextVP[j];
			}
		}
		//else
		//{
			j = nextVP[j];
		//}
	}
	
	//Search the 2 arrays
	i = 0;
	j = 0;
	//while (i < packageLength && j < wordLength)
	while (i <= (Int16)packageLength - (Int16)wordLength)
	{
		while (j == -1 || (j < wordLength && (packageP[i] & wordP[j])))
		{
			i ++;
			j ++;
		}
		
		if (j == wordLength)
		{
			return true;
		}
		
		//else
		//{
			j = nextVP[j];
		//}
	}
	/*if (j == wordLength)
	{
		return true;
	}
	else
	{
		return false;
	}*/
	return false;
}

//ַתUInt32λװ
static void convertCharsToBitPackage(Char *srcStringP, UInt32 *pyTableP, UInt32 *destUInt32BitPackageP, UInt16 *UInt32BitPackageLengthP)
{
	WChar		chr;
	
	(*UInt32BitPackageLengthP) = 0;
	
	while (*srcStringP/* && (*UInt32BitPackageLengthP) < 5*/)
	{
		if (((UInt8)(*srcStringP)) > 127 && pyTableP)	//
		{
			MemMove(&chr, srcStringP, 2);
			srcStringP += 2;
			destUInt32BitPackageP[(*UInt32BitPackageLengthP)] = (pyTableP[chr - 33088] & PRONUNCIATION_COUNT);
		}
		else if (((UInt8)(*srcStringP)) >= 97 && ((UInt8)(*srcStringP)) <= 122)	//дӢ
		{
			destUInt32BitPackageP[(*UInt32BitPackageLengthP)] = (((UInt32)1) << ((*srcStringP) - 97));
			srcStringP ++;
		}
		else if (((UInt8)(*srcStringP)) >= 65 && ((UInt8)(*srcStringP)) <= 90)	//СдӢ
		{
			destUInt32BitPackageP[(*UInt32BitPackageLengthP)] = (((UInt32)1) << ((*srcStringP) - 65));
			srcStringP ++;
		}
		else	//
		{
			destUInt32BitPackageP[(*UInt32BitPackageLengthP)] = (UInt32)(*srcStringP);
			destUInt32BitPackageP[(*UInt32BitPackageLengthP)] |= 0x80000000;
			srcStringP ++;
		}
		(*UInt32BitPackageLengthP) ++;
	}
}

//ַзϵ绰׼ַ
static UInt16 StrDigitCopy(Char *dstStringP, Char *srcStringP)
{
	UInt16 dstLength = 0;
	
	while (*srcStringP)
	{
		if (TxtCharIsDigit(*srcStringP) || (*srcStringP) == '+' || (*srcStringP) == '*' || (*srcStringP) == '#')
		{
			dstStringP[dstLength] = *srcStringP;
			dstLength ++;
		}
		srcStringP ++;
	}
	
	dstStringP[dstLength] = 0x00;

	return dstLength;
}

//ַ
static void paintCharsWithOutline(Char *stringP, UInt16 stringLength, Coord x, Coord y, RGBColorType *outlineColorP)
{
	RGBColorType	defaultColor;
	UInt16			density			= kDensityDouble;
	
	//
	WinSetTextColorRGB(outlineColorP, &defaultColor);
	if (WinGetSupportedDensity(&density) != errNone)		//ָ֧߷ֱĻ
	{
		WinPaintChars(stringP, stringLength, x - 1, y - 1);
		WinPaintChars(stringP, stringLength, x + 1, y - 1);
		WinPaintChars(stringP, stringLength, x - 1, y + 1);
		WinPaintChars(stringP, stringLength, x + 1, y + 1);
	}
	else	//߷Ļ
	{
		Coord	dX = x * 2;
		Coord	dY = y * 2;
		
		WinSetCoordinateSystem(kCoordinatesDouble);
		WinPaintChars(stringP, stringLength, dX - 1, dY - 1);
		WinPaintChars(stringP, stringLength, dX + 1, dY - 1);
		WinPaintChars(stringP, stringLength, dX - 1, dY + 1);
		WinPaintChars(stringP, stringLength, dX + 1, dY + 1);
		WinSetCoordinateSystem(kCoordinatesStandard);
	}
	WinSetTextColorRGB(&defaultColor, NULL);
	
	//ַ
	WinPaintChars(stringP, stringLength, x, y);
}

//ͨѶ¼
static void freeCallLog(GlobeType *globeP)
{
	if (globeP->callLogListP != NULL)
	{
		MemPtrFree(globeP->callLogListP);
		globeP->callLogListP = NULL;
	}
	globeP->callLogCount = 0;
}

/*static void freeContactList(GlobeType *globeP)
{
	UInt16	i;
	
	//ѭͷŽڵڴ
	for (i = 0; i < globeP->contactListCount; i ++)
	{
		MemPtrFree(globeP->contactListPP[i]);
	}
	
	//ýڵ
	globeP->contactListCount = 0;
}*/

//ͷͨѶ¼ڴ
static void freeContactCategory(GlobeType *globeP)
{
	UInt16		i;
	
	for (i = 0; i < globeP->contactCategoryCount; i ++)
	{
		MemPtrFree(globeP->contactCategoryPP[i]);
	}
	
	MemPtrFree(globeP->contactCategoryPP);
}

//ͨѶ¼Ԫڴ棬ȡͨѶ¼
static Boolean getContactUnitMemoryAndCategory(GlobeType *globeP)
{
	DmOpenRef		dbRef		= DmOpenDatabaseByTypeCreator('DATA', 'PAdd', dmModeReadOnly);
	
	if (DmGetLastErr() == errNone)
	{
		UInt16					i;
		UInt16					recordNums	= DmNumRecordsInCategory(dbRef, dmAllCategories) + 1;
		ContactCategoryType		*recordP	= MemLocalIDToLockedPtr(DmGetAppInfoID(dbRef), 0);
		
		globeP->fieldMappingP = (FieldMappingType *)MemGluePtrNew(recordNums * 32);
		
		globeP->contactCategoryPP = (Char **)MemPtrNew(68);
		globeP->contactCategoryPP[0] = (Char *)MemPtrNew(16);
		StrCopy(globeP->contactCategoryPP[0], STRING_CONTACTS_CATEGORY_ALL);
		globeP->contactCategoryCount = 1;
		for (i = 0; i < 15; i ++)
		{
			if (/*((((UInt32)1) << i) & recordP->flag) && */(UInt8)recordP->categoryPP[i][0] != 0)
			{
				//
				globeP->contactCategoryPP[globeP->contactCategoryCount] = (Char *)MemPtrNew(16);
				StrCopy(globeP->contactCategoryPP[globeP->contactCategoryCount], recordP->categoryPP[i]);
				
				//ӳ
				globeP->contactCategoryMappingP[globeP->contactCategoryCount] = i;
				
				globeP->contactCategoryCount ++;
			}
		}
		
		MemPtrUnlock(recordP);
		
		DmCloseDatabase(dbRef);
		return true;
	}
	
	return false;
}

//ȡͼ
static BitmapTypeV3 *getBackgdBitmap(LauncherSettingType *launcherSettingP)
{
	UInt16			error;
	FileHand		fileH;
	void			*bmpBitsP	= NULL;
	BitmapTypeV3	*bmpV3P		= NULL;
	
	if (launcherSettingP->shouldShowBackgd)
	{
		//ͷžɵıͼ
		if (FtrGet(APPLICATION_CREATOR, LAUNCHER_BITMAP_BITS_FEATURE_ID, (UInt32 *)&bmpBitsP) != errNone)
		{
			//FtrPtrFree(APPLICATION_CREATOR, LAUNCHER_BITMAP_BITS_FEATURE_ID);
			//ȡͼ
			fileH = FileOpen(0, LAUNCHER_WALLPAPER_CACHE_NAME, sysFileTFileStream, APPLICATION_CREATOR, fileModeReadOnly, &error);
			if (error == errNone)
			{
				UInt32		width, height;
				Int32		bmpBitsSize;
				
				FileTell(fileH, &bmpBitsSize, &error);
				bmpBitsSize -= 8;
				FileRead(fileH, &width, 4, 1, &error);
				FileRead(fileH, &height, 4, 1, &error);
				
				if (error == errNone)
				{
					BitmapType	*bmpP	= BmpCreate(width, height, 16, NULL, &error);
					
					if (error == errNone)
					{
						if (FtrPtrNew(APPLICATION_CREATOR, LAUNCHER_BITMAP_BITS_FEATURE_ID, bmpBitsSize, &bmpBitsP) == errNone)
						{
							FileDmRead(fileH, bmpBitsP, 0, bmpBitsSize, 1, &error);
							
							if (error == errNone)
							{
								bmpV3P = BmpCreateBitmapV3(bmpP, kDensityDouble, bmpBitsP, NULL);
							}
							else
							{
								FtrPtrFree(APPLICATION_CREATOR, LAUNCHER_BITMAP_BITS_FEATURE_ID);
							}
						}
						BmpDelete(bmpP);
					}
				}
				
				FileClose(fileH);
			}
		}
		else
		{
			//ȡͼϢ
			fileH = FileOpen(0, LAUNCHER_WALLPAPER_CACHE_NAME, sysFileTFileStream, APPLICATION_CREATOR, fileModeReadOnly, &error);
			if (error == errNone)
			{
				UInt32		width, height;
				Int32		bmpBitsSize;
				
				FileTell(fileH, &bmpBitsSize, &error);
				bmpBitsSize -= 8;
				FileRead(fileH, &width, 4, 1, &error);
				FileRead(fileH, &height, 4, 1, &error);
				
				if (error == errNone)
				{
					BitmapType	*bmpP	= BmpCreate(width, height, 16, NULL, &error);
					
					if (error == errNone)
					{
						bmpV3P = BmpCreateBitmapV3(bmpP, kDensityDouble, bmpBitsP, NULL);
						BmpDelete(bmpP);
					}
				}
				
				FileClose(fileH);
			}
		}
	}
	
	return bmpV3P;
}

//ͷλͼԴ
static void freeBmpResource(GlobeType *globeP)
{
	UInt16			i;
	
	for (i = 0; i < 3; i ++)
	{
		MemPtrFree(globeP->bmpP[i]);
	}
}

//ȡλͼԴ
static void getBmpResource(GlobeType *globeP)
{
	UInt16			resourceId;
	UInt32			bmpSize;
	MemHandle		rscH;
	DmOpenRef		dbRef		= DmOpenDatabaseByTypeCreator('NlPh', APPLICATION_CREATOR, dmModeReadOnly);
	
	for (resourceId = bmpIncoming; resourceId <= bmpOutgoing; resourceId ++)
	{
		rscH = DmGet1Resource('Tbmp', resourceId);
		bmpSize = MemHandleSize(rscH);
		globeP->bmpP[resourceId - bmpIncoming] = (BitmapType *)MemPtrNew(MemHandleSize(rscH));
		MemMove(globeP->bmpP[resourceId - bmpIncoming], MemHandleLock(rscH), bmpSize);
		MemHandleUnlock(rscH);
		DmReleaseResource(rscH);
	}
	
	DmCloseDatabase(dbRef);
}

static void getPYTable(GlobeType *globeP)
{
	UInt16			contactSearchLibRef;
	UInt32			ctx;
	
	//Դƴ⣬ƴת
	if (CLibLoad(&contactSearchLibRef, &ctx) == errNone)
	{
		if (FtrGet(CLibCreatorID, PY_TABLE_FTR_NUMBER, (UInt32 *)&globeP->pyTableP) != errNone)
		{
			globeP->pyTableP = NULL;
		}
	}
	else
	{
		globeP->pyTableP = NULL;
	}
	
	//رƴ
	if (globeP->pyTableP != NULL)
	{
		CLibRemove(contactSearchLibRef, ctx);
	}
}

static void freeCallCard(GlobeType *globeP)
{
	UInt16			i;
	
	for (i = 0; i < globeP->callCardCount; i ++)
	{
		MemPtrFree(globeP->callCardsPP[i]);
	}
	MemPtrFree(globeP->callCardsPP);
	globeP->callCardCount = 0;
}

static void getPreferences(GlobeType *globeP)
{
	UInt16			i;
	UInt16			settingSize	= sizeof(SettingType);
	SettingType		*settingP	= (SettingType *)MemPtrNew(settingSize);
	
	if (PrefGetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, settingP, &settingSize, true) == noPreferenceFound)
	{
		MemSet(settingP, settingSize, 0);
		
		StrCopy(settingP->callCardPP[0], STRING_DEFAULT_CALL_CARD);
		
		//
		PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, settingSize, true);
	}
	
	if (globeP != NULL)
	{
		globeP->defaultView = settingP->defaultView;
		
		globeP->callCardsPP = (Char **)MemPtrNew(24);
		globeP->callCardsPP[0] = (Char *)MemPtrNew(12);
		StrCopy(globeP->callCardsPP[0], STRING_DIAL);
		globeP->callCardCount ++;
		
		for (i = 0; i < 5; i ++)
		{
			if ((UInt8)settingP->callCardPP[i][0] != 0)
			{
				globeP->callCardsPP[globeP->callCardCount] = (Char *)MemPtrNew(12);
				StrCopy(globeP->callCardsPP[globeP->callCardCount], "+");
				StrCat(globeP->callCardsPP[globeP->callCardCount], settingP->callCardPP[i]);
				globeP->callCardCount ++;
			}
		}
	}
	
	MemPtrFree(settingP);
}

#if 0
#pragma mark -
#pragma mark START UP FUNCTIONS
#pragma mark -
#endif

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	if (cmd == LAUNCH_CODE_PLUGIN_ACTION)		//
	{
		switch (((PluginParameterType *)cmdPBP)->actionType)
		{
			case ACTION_TYPE_KEY:
				phoneMainEventHandler((PluginParameterType *)cmdPBP);
				break;
			case ACTION_TYPE_SETUP:
				settingEventHandler();
				break;
		}
	}

	return errNone;
}
