/*
 * PhonePlugin.h
 *
 * header file for PhonePlugin
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */

#ifndef PHONEPLUGIN_H_
#define PHONEPLUGIN_H_

#include "CLib.h"

/*********************************************************************
 * Internal Structures
 *********************************************************************/

typedef struct
{
	UInt16				cardNo;
	LocalID				dbId;
	UInt32				type;
	UInt32				creatorId;
	UInt8				categoryId;
	Char				shortcut;
	UInt16				addOnInfo;
}ProgramListType;

typedef struct
{
	UInt8				deviceModel;
	Boolean				shouldRelayKey;
	UInt8				isInPhone;	//0 ʾͨУ1ʾ绰2ʾ绰
	Boolean				useAsDefaultLauncher;
}NotifyParameterType;

typedef struct
{
	Char					nameP[21];

	SoundPreference			imSoundPrefs;
	SoundPreference			phoneSoundPrefs;
	SoundPreference			emailSoundPrefs;
	SoundPreference			calendarSoundPrefs;
	SoundPreference			smsSoundPrefs;
	SoundPreference			mmsSoundPrefs;

	UInt8					systemVolume;
	UInt8					alertVolume;
	UInt8					gameVolume;
	UInt8					reserved;
}ProfileType;

typedef struct
{
    UInt8               deviceModel;
    NotifyParameterType notifyParameter;

    RGBColorType        formFrameColor;
    RGBColorType        formFillColor;
    RGBColorType        topStatusFillColor;
    RGBColorType        statusDigitalColor;
    RGBColorType        textColor;
    RGBColorType        textOutlineColor;
    RGBColorType        textOnMaskColor;
    RGBColorType        focusRingColor[6];

    Boolean             useAsDefaultLauncher;
    UInt8               ReturnToLauncherAfterCall; // 0:  1: 2: 3:ȫ

    Boolean             shouldSearchProgramWhenKeyPressed;
    Boolean             shouldEnableHoldKeyRunProgram;
    Boolean             shouldShowShortCut;
    
    Boolean             useCustomCarrier;
    Char                customCarrierP[21];
    Boolean             shouldShowDateTime;
    Boolean             shouldShowCalendar;
    Boolean             shouldAddMask;
    Boolean             shouldAddLine;
    Boolean             shouldShowTopIcons;
    Boolean             shouldShowTopPrograms;
    PatternType         maskPattern;
    UInt8               focusRingStyle;
    Boolean             shouldShowBackgd;

    Boolean             shouldSkipAllCategory;
    Boolean             shouldSkipEmptyCategory;
    Boolean             shouldSearchInGlobe;
    Boolean             shouldShowSearch;
    Boolean             shouldLaunchTheOnlyMatchedProgram;
    Boolean             shouldActivePluginInPhoneViewOnly;
    Boolean             shouldAutoRaiseProgram;
    Boolean             shouldAutoUpdateProgramList;
    Boolean             shouldDrawOutline;

    ProfileType         profiles[5];
    UInt8               lastProfile;
    Boolean             shouldEnableProfileManagement;
    WChar               ProfileActiveKey;

    Boolean             isNotificationRegistered;
    Boolean             isPhoneLibraryRegistered;

    UInt8               lastCategory;

    ProgramListType     lastProgramLaunchFromCard;
}LauncherSettingType;

//---------------------------------------------------------

typedef struct
{
	Boolean				shouldRelayKey;
	UInt8				defaultView;
	Char				callCardPP[5][11];
}SettingType;

typedef struct
{
	UInt16				flags;
	DateType			date;
	TimeType			time;
	UInt32				duration;
	Char				nameString[];
}PhoneCallDBType;

typedef struct
{
	UInt16				flag;
	Char				categoryPP[16][16];
}ContactCategoryType;

typedef struct
{
	UInt16				recordId;
	UInt8				category;
}CallLogItemType;

typedef struct
{
	UInt16					recordId;
	UInt8					field;
	UInt8					matchType;
}FieldMappingType;

typedef struct
{
	UInt8				defaultDisplayEffect;
	PatternType			defaultMaskPattern;
	RGBColorType		textColor;
	RGBColorType		textOutlineColor;
	RGBColorType		foreColor;
	RGBColorType		backgdColor;

	UInt8				defaultView;

	Char				**callCardsPP;
	UInt16				callCardCount;

	RectangleType		backgdRectangle;
	RectangleType		statusBarRectangle;
	RectangleType		datetimeBarRectangle;
	RectangleType		tabRectangle;
	RectangleType		listBarRectangle;
	RectangleType		dialPadRectangle;
	RectangleType		phoneNumberRectangle[2];

	WinHandle			offscreenWindowH;

	FormType			*frmPhoneUIP;
	ListType			*lstContentTypeP;
//	ControlType			*ptriPhoneCategoryListP;
//	ListType			*lstPhoneCategoryListP;
	TableType			*tblPhoneListP;
	UInt16				tblPhoneListIndex;
	ScrollBarType		*sclPhoneListP;
	UInt16				sclPhoneListIndex;
	ControlType			*btnPhoneButtonsP[12];
	ListType			*lstPhoneDialP;
	ControlType			*btnPhoneDialP;
	ListType			*lstPhoneContactP;
	ControlType			*btnPhoneContactP;
	ControlType			*btnPhoneTextP;
	ControlType			*btnPhoneClearP;
	ControlType			*btnPhoneCancelP;

	UInt16				focusedObjectId;
	Int16				selectedRow;
	Boolean				shouldIgnoreFldChangedEvent;
	Boolean				shouldResetSelectedRow;

	Char				phoneNumberP[64];

	BitmapTypeV3		*bmpBackgroundP;
	BitmapType			*bmpCharP[14];
	BitmapType			*bmpTrigerP;
	BitmapType			*bmpP[3];
	BitmapType			*bmpSoundStatusP[10];

	UInt16				pmGadgetLibRef;
	UInt16				hsPhoneLibRef;

	Char				operatorNameP[33];
	Char				*dateStringP;
	Char				*timeStringP;

	Coord				insPtX;
	Coord				insPtY;

	Boolean				isGadgetActived;
	Boolean				isMenuActived;

	Boolean				shouldEraseInsPt;
	Boolean				isInsPtDrawed;

	UInt8				setTableContent;

	UInt8				contentType;

	UInt8				callLogCategory;
	CallLogItemType		*callLogListP;
	UInt16				callLogCount;
	Char				**callLogCategoryPP;

	UInt32				*pyTableP;

	UInt8				contactsCategory;
	AddrDBRecordType	*contactUnitP;
	Char				**contactCategoryPP;
	UInt16				contactCategoryCount;
	UInt16				contactCategoryMappingP[16];

	FieldMappingType	*fieldMappingP;
	UInt16				fieldMappingCount;

	Char				contactSearchKeywordP[11];
	UInt32				contactSearchKeywordUInt32PackageP[11];
	UInt16				contactSearchKeywordLength;
	UInt32				nameUInt32PackageP[128];
	UInt16				nameUInt32PackageLength;
	Int16				nextVP[10];

	Char				cacheP[128];
}GlobeType;

//ö
typedef enum
{
	PHONE_EVENT_NETWORK_SEARCHING	= sysEventFirstUserEvent + 0x0406,
	PHONE_EVENT_POWER_ON,
	PHONE_EVENT_POWER_OFF,
	PHONE_EVENT_HOME,
	PHONE_EVENT_OTHER,
	NOTIFY_EVENT_DB,
	NOTIFY_EVENT_CARD_MOUNT,
	NOTIFY_EVENT_CARD_UNMOUNT
} CustomEventEnum;

/*********************************************************************
 * Internal Constants
 *********************************************************************/

#define APPLICATION_CREATOR					'nLch'
#define LAUNCHER_PREFERENCE_ID				0x00
#define LAUNCHER_BITMAP_BITS_FEATURE_ID		0x01
#define PREFERENCE_ID						0x01
#define PREFERENCE_VERSION					0x01
#define NOTIFY_PARAMETER_FEATURE_ID			0x02
#define LAUNCHER_WALLPAPER_CACHE_NAME		"NLnchWallpaper"

#define BMP_INCOMING						0x00
#define BMP_OUTGOING						0x01
#define BMP_MISSED							0x02

#define TABLE_ROWS_NUMS						0x09

#define FORM_UPDATE_NO_UPDATE				0xFFFF
#define FORM_UPDATE_ALL						0x8000
#define FORM_UPDATE_STATUS_BAR_ONLY			0x0001
#define FORM_UPDATE_LAUNCH_BAR_ONLY			0x0002
#define FORM_UPDATE_CONTENT					0x0003
#define FORM_UPDATE_REFRESH					0x0004
#define FORM_UPDATE_PHONE_NUMBER			0x0005

#define PHONE_ACTION_NO_EXIT				0x00
#define PHONE_ACTION_EXIT					0x01

#define SET_TABLE_CONTENT_NA				0x00
#define SET_TABLE_CONTENT_CALL_LOG			0x01
#define SET_TABLE_CONTENT_CONTACTS			0x02
#define SET_TABLE_CONTENT_DIAL_PAD			0x03

#define CONTENT_TYPE_CALL_LOG				0x00
#define CONTENT_TYPE_CONTACTS				0x01
#define CONTENT_TYPE_DIAL_PAD				0x02

#define CALL_LOG_CATEGORY_INCOMING			0x01
#define CALL_LOG_CATEGORY_MISSED			0x02
#define CALL_LOG_CATEGORY_OUTGOING			0x03
#define CALL_LOG_CATEGORY_ALL				dmAllCategories

#define MATCH_TYPE_NONE						0x00
#define MATCH_TYPE_NAME						0x01
#define MATCH_TYPE_PHONE					0x02

#define TREO_680_GREEN_KEY					0x021A

#define STRING_DEVICE_ERROR					"Treoϵֻϣ"
#define STRING_PHOTO_LIB_ERROR				"޷ͼƬ⣡"
#define STRING_PHONE_OFF					"绰ر"
#define STRING_PHONE_ON						"绰"
#define STRING_NETWORK_SEARCHING			"С"
#define STRING_ALL_CATEGORIER				"ȫ"
#define STRING_CARD							"濨"
#define STRING_FIND							""
#define STRING_FOCUS_RING_COLOR_CONFIRM		"NeoLauncherΪԶ㽹Ľɫ\n"
#define STRING_REBUILD_LIST_CONFIRM			"ؽͳбɾǰķϢбָϵͳĬϵ\n"
#define STRING_LAUNCH_ERROR					"ʧܣ"
#define STRING_SHORTCUT_CHARACTER_ERROR		"ݼAZӢĸ"
#define STRING_SHORTCUT_EXIST_ERROR			"ݼѾʹã"
#define STRING_CLEAR_SHORTCUT_CONFIRM		"ݼ\n"
#define STRING_SHORTCUT_NOT_DEFINED			"ݼδ壡\nݼڲ˵ġͿݼж壩"
#define STRING_CALL_LOG						"ͨ¼"
#define STRING_CONTACTS						"ͨѶ¼"
#define STRING_CALL_LOG_CATEGORY_ALL		"ȫ"
#define STRING_CALL_LOG_CATEGORY_INCOMING	""
#define STRING_CALL_LOG_CATEGORY_OUTGOING	""
#define STRING_CALL_LOG_CATEGORY_MISSED		"δ"
#define STRING_CONTACTS_CATEGORY_ALL		"ȫ"
#define STRING_NO_RECORDS					"ûм¼"
#define STRING_DEFAULT_CALL_CARD			"17951"
#define STRING_DIAL							""
#define STRING_DIAL_PAD						""
/*
#define STRING_DEVICE_ERROR					"This program supports Treo series only!"
#define STRING_PHOTO_LIB_ERROR				"Can't load Photo Library!"
#define STRING_PHONE_OFF					"Phone Off"
#define STRING_PHONE_ON						"Phone On"
#define STRING_NETWORK_SEARCHING			"Network Search..."
#define STRING_ALL_CATEGORIER				"All"
#define STRING_CARD							"Storage Card"
#define STRING_FIND							"Find"
#define STRING_FOCUS_RING_COLOR_CONFIRM		"NeoLauncher can calculate the rest ring color automatically\nDo you want to continue?"
#define STRING_REBUILD_LIST_CONFIRM			"The category and program list will be delete and restore to the system default!\nAre you sure to continue?"
#define STRING_LAUNCH_ERROR					"Launch failed!"
#define STRING_SHORTCUT_ERROR				"Shortcut must be the character from A-Z!"
#define STRING_SHORTCUT_EXIST_ERROR			"Shortcut exist!"
#define STRING_CLEAR_SHORTCUT_CONFIRM		"Shortcut will be delete!\nDo you want to continue?"
#define STRING_SHORTCUT_NOT_DEFINED			"Shortcut is not defined!\n(Shortcut can be defined in menu 'Category & Shortcut')"
#define STRING_CALL_LOG						"Call Log"
#define STRING_CONTACTS						"Contacts"
#define STRING_CALL_LOG_CATEGORY_ALL		"All"
#define STRING_CALL_LOG_CATEGORY_INCOMING	"Incoming"
#define STRING_CALL_LOG_CATEGORY_OUTGOING	"Outgoing"
#define STRING_CALL_LOG_CATEGORY_MISSED		"Missed"
#define STRING_CONTACTS_CATEGORY_ALL		"All"
#define STRING_NO_RECORDS					"No Records"
#define STRING_DEFAULT_CALL_CARD			"17951"
#define STRING_DIAL							"Dial"
#define STRING_DIAL_PAD						"Dial Pad"
*/

#define GET_OBJECT_POINTER(f, o)			FrmGetObjectPtr(f, FrmGetObjectIndex(f, o))

#endif /* PHONEPLUGIN_H_ */
